-- Table: candidatos

DROP TABLE IF EXISTS candidatos;

CREATE TABLE candidatos
(
  id serial NOT NULL,
  soporte integer,
  item text,
  CONSTRAINT candidatos_pkey PRIMARY KEY (id)
) 
WITHOUT OIDS;
ALTER TABLE candidatos OWNER TO upolaris;

-- Table: log

DROP TABLE IF EXISTS log;

CREATE TABLE log
(
  id serial NOT NULL,
  hostremoto text,
  auser text NOT NULL DEFAULT 'anonimo'::text,
  fecha date,
  hora time without time zone,
  metodo text NOT NULL DEFAULT 'GET'::text,
  peticion text,
  protocolo text,
  estado integer DEFAULT 400,
  bytes integer DEFAULT 0,
  referencia text,
  agenteu text,
  idpeticion integer,
  idreferencia integer,
  idagenteu integer,
  CONSTRAINT log_pkey PRIMARY KEY (id)
) 
WITHOUT OIDS;
ALTER TABLE log OWNER TO upolaris;

-- Table: sesioncomun

DROP TABLE IF EXISTS sesioncomun;

CREATE TABLE sesioncomun
(
  hostremoto text NOT NULL,
  fechahorainicio timestamp without time zone NOT NULL,
  fechahorafin timestamp without time zone,
  numsolicitudes integer DEFAULT 1,
  totalbytes integer DEFAULT 0,
  tiposficheros integer[],
  pagvisitadas integer[],
  nomtipofichero text[],
  nompagvisitadas text[],
  id serial NOT NULL,
  CONSTRAINT sesioncomun_pkey PRIMARY KEY (hostremoto, fechahorainicio)
) 
WITHOUT OIDS;
ALTER TABLE sesioncomun OWNER TO upolaris;

-- Table: sesionextendida

DROP TABLE IF EXISTS sesionextendida;

CREATE TABLE sesionextendida
(
  hostremoto text NOT NULL,
  agenteu text NOT NULL,
  fechahorainicio timestamp without time zone NOT NULL,
  fechahorafin timestamp without time zone,
  numsolicitudes integer DEFAULT 1,
  totalbytes integer DEFAULT 0,
  nomtipofichero text[],
  tiposficheros integer[],
  transacciones text[],
  id serial NOT NULL,
  nompagvisitadas text[],
  CONSTRAINT sesionextendida_pkey PRIMARY KEY (hostremoto, agenteu, fechahorainicio)
) 
WITHOUT OIDS;
ALTER TABLE sesionextendida OWNER TO upolaris;
