/**
 * fillDataSet.java
 *
 * Created on 12 de mayo de 2007, 03:16 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Utils;

import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Savepoint;
import java.sql.Statement;
import java.util.Vector;
import Utils.conexion;


/**
 *  Llenar Data Set para comunicarse con los algoritmos de asociacion (de Tariy)
 *  Esto servira para la reutilizacion de codigo, ya preparado por GRIAS.
 *
 *  Lo que se pretende es preparar la entrada de datos de los algoritmos de asociacion
 *  que para el caso es un DataSet.
 *
 * @author Proyecto *** Polaris *** Johana
 */

public class fillDataSet {
    
    conexion conx;
    DataSet dataset;    
    int tipoSesion;
    String sesion;
    
    /** Creates a new instance of fillDataSet */
    public fillDataSet(int tipoS) {
        tipoSesion= tipoS; // especifica que sesion es la que se va a analizar
        if(tipoSesion==1){
            sesion="sesioncomun";            
        }else{
            sesion="sesionextendida";
        }
        //
        //inicializo conexion con BDLog
    	// Instanciar conx
    	conx= new conexion();
    	// Abrir conexion a BD logs
    	conx.conectar("polaris","upolaris","ppolaris");   
        // *** Inicializo DataSet
        dataset = new DataSet("");
    }
    
    /**
     * Se encarga de cargar los datos de las sesiones en la entrada de los algoritmos de Asociacion
     * tales como Apriori, Equipasso, FP Growth
     *
     * Se obtienen los datos de la tabla sesion (ya sea comun o extendida)
     * de nuestra base de datos Polaris
     */
    public DataSet loadDataSet(){
        String query;
        ResultSet rs;
               //                
        try {
            query = "SELECT distinct peticion FROM log ORDER BY peticion";
            rs= conx.consulta1(query);            
            rs.next();
            rs.first();
            dataset.buildDictionary(rs);            
        } catch (Exception ex) {
            System.out.println("Error en la construccion del diccionario" + ex.getMessage());            
        }
        try{
            // contar cuantos registros hay en la tabla de sesion 
            query= "SELECT count(*) FROM " + sesion;
            rs= conx.consulta1(query);            
            rs.next();
            //
            int nfilas = rs.getInt(1);
            // sacar registros que hay en la tabla de sesion 
            query= "SELECT nompagvisitadas FROM " + sesion;
            rs= conx.consulta1(query);            
            //
            rs.first();                        
            Short item;            
            int id = 1;
            String transaccion;
            int ini,fin,nitem;
            //
            for(int i=0;i<nfilas;i++){
                transaccion= rs.getString(1);
                ini=0;
                fin=0;
                nitem=0;
                while(fin!=-1){
                    ini= fin+1;
                    fin= transaccion.indexOf(',',ini);
                    //
                    id=1;
                    if(ini==1) id=0;                    
                    //
                    if(fin!=-1) {
                        item= Short.valueOf(transaccion.substring(ini,fin)); nitem++;
                    }
                    else{
                        id=-1;
                        if(nitem==0) id=-2;
                        fin= transaccion.indexOf('}',ini);
                        item= Short.valueOf(transaccion.substring(ini,fin)); nitem++;
                        fin=-1;
                    }
                    //
                    dataset.buildNTree(item,id);
                    //
                }
                //
                rs.next();
            }
            //            
            System.gc();
            dataset.setName("Log");
//                      
        } catch (SQLException esql){
            System.out.println("Error en la construccion del DataSet" + esql.getMessage());            
        }        
        return dataset;
    }
    
}
