/**
 * build_decisionTree.java
 *
 * Created on 22 de junio de 2007, 10:25 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification.c45_1;

import algorithm.classification.ClassificationTableModel;
import algorithm.classification.clasesAtrib;
import algorithm.classification.elemento;
import algorithm.classification.sesiontrans;
import java.util.ArrayList;
import java.util.Vector;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class build_decisionTree {
    
    // ***
    String claseT; /** Clase Target o punto de decision */   
    clasesAtrib valorPerAtrib; /** Tiene todos los posibles Atributos con los posibles valores */
    int colT; /** El indice de la columna de la clase target */
    // ***    
    
    /** Creates a new instance of build_decisionTree */
    public build_decisionTree(String Target, int indT, clasesAtrib cAtrib) {
        claseT= Target;        
        colT= indT;
        valorPerAtrib= cAtrib;
    }
    
    /** Construye el arbol de decision a partir de una tabla de datos de la sesion transformada
     *  los atributos a Analizar y la clase Target
     */
    public elemento  decisionTree(ClassificationTableModel examples,ArrayList atributes, elemento defAnswer) {
        // *** 
        elemento raizA, aux; // arbol
        elemento subarbol, sameCla; // subarbol
        //elemento aux, auxraiz;
        String mejor="", valorI=""; // mejor atributo, valor de i
        Vector valores; // valores del mejor atributo
        String mensaje=""; // mensaje no idea
        int i,indice;
        ClassificationTableModel examplesVi;
        ArrayList atributosFaltantes;
        // ***
        sameCla= isSameClassification(examples); // Ver si es de igual valor de la clase Target
        if(examples.getRowCount()==0){  // Si ya no hay filas que analizar          
            return defAnswer; // la respuesta por defecto
        }
        else if(sameCla!=null){  // Si es de igual Clasificacion          
            return sameCla; // retornar esa clasificacion
        }
        else if(atributes.size()==0){ // Si ya no hay atributos que analizar
            return valorMayoritario(examples); // Escoger el valor de la clase Target que mas aparece
        }
        else{  
            mejor= escogeAtributo(atributes,examples); // Selecciono el atributo de mejor valor
            raizA= new elemento(mejor);
            valores= valorPerAtrib.getValores(mejor);
            //      
            for(i=0;i<valores.size();i++){
                valorI= valores.elementAt(i).toString();
                // 1. Sacamos la tabla para el valor - 2. Quitamos a mejor de los Atrib Condicion - 3. Vamos a la rama
                examplesVi= obtenerEjemplosVi(examples, mejor, valorI);
                atributosFaltantes= sacarMejor(atributes, mejor);                
                subarbol= decisionTree(examplesVi, atributosFaltantes, valorMayoritario(examples));
                // Pongo el valor como hijo de raiz, y a subarbol como hijo de valor
                aux= new elemento(valorI);
                aux.hijos[0]= subarbol;
                raizA.hijos[i]= aux;
                raizA.incNumhijos();
                //
            }
            return raizA;  
        }
        //        
    }
    
    /** Saca el atributo que ya ha sido escogido */
    public ArrayList sacarMejor(ArrayList atributos, String mejor){
        atributos.remove(mejor);
        return atributos;
    }
    
    /** Obtiene los ejemplos que se analiza para determinado valor en el atributo mejor */
    public ClassificationTableModel obtenerEjemplosVi(ClassificationTableModel ejemplos, String mejorA, String valori){
        sesiontrans fila;
        ArrayList newdatos= new ArrayList();
        ClassificationTableModel subejemplo;
        int i, n=ejemplos.getRowCount() , colmejor=ejemplos.getColumnIndex(mejorA);
        String dato;
        //
        for(i=0;i<n;i++){
            fila= ejemplos.getSesionAt(i);
            dato="";
            //
            switch(colmejor){
                case 0:
                    dato= fila.getTipoIP();
                    break;
                case 1:
                    dato= fila.getHorario();
                    break;
                case 2:
                    dato= fila.getDiaSemana();
                    break;
                case 3:
                    dato= fila.getDuracion();
                    break;
                case 4:
                    dato= fila.getCantPet();
                    break;
                case 5:
                    dato= fila.getTamDescarga();
                    break;
            }
            //
            if(dato.equals(valori)){
                newdatos.add(fila);
            }
        }
        subejemplo= new ClassificationTableModel(newdatos);
        //
        return subejemplo;
    }
    
    /** Escoge el mejor atributo, es decir, el de menor entropia, en la tabla ejemplos */
    public String escogeAtributo(ArrayList atributes, ClassificationTableModel examples){
        String bestAtribute="", nomA="", dato;
        int i,j,k, colA, n;
        double menorE, eni;
        valorAtributo auxraiz, auxnodo, auxn;
        boolean findit;
        //
        menorE=100.0;
        for(i=0;i<atributes.size();i++){
            nomA= atributes.get(i).toString();
            auxraiz= new valorAtributo(nomA);
            auxraiz.setFrec(examples.getRowCount());
            //
            colA= examples.getColumnIndex(nomA); n=0;
            for(j=0;j<examples.getRowCount();j++){
                dato= examples.getValueAt(j,colA).toString();
                //
                auxn= auxraiz.hijo;
                if(auxn==null){
                    auxnodo= new valorAtributo(dato);
                    auxnodo= colocarhijos(auxnodo,examples.getValueAt(j,colT).toString());
                    auxraiz.hijo= auxnodo;
                }else{
                    findit=false;                
                    while(findit==false){
                        if(auxn.getNombre().equals(dato)){
                            findit=true;
                            auxn.incFrec();
                            auxn= colocarhijos(auxn,examples.getValueAt(j,colT).toString());
                        }
                        else{
                            if(auxn.hermano==null && findit==false){
                                auxnodo= new valorAtributo(dato);
                                auxnodo= colocarhijos(auxnodo,examples.getValueAt(j,colT).toString());
                                auxn.hermano= auxnodo;
                                findit=true;
                            }else{
                                auxn= auxn.hermano;
                            }
                        }
                    }
                }                
                //                
            }
            // se cargo todo el arbol y asi calculamos la entropia
            eni= calcularEntropia(auxraiz);
            if(eni<menorE){
                menorE=eni;
                bestAtribute= nomA;
            }
        }
        //
        return bestAtribute;
    }
    
    /** Calcula la entropia de un Atributo */
    public double calcularEntropia(valorAtributo araiz){
        double entropia=0.0, operar;
        valorAtributo auxb;
        //
        auxb= araiz.hijo;
        while(auxb!=null){
            //
            operar= Double.parseDouble(String.valueOf(auxb.getFrec()))/araiz.getFrec();
            operar= operar * calcularE(auxb);
            entropia= entropia + operar;
            //
            auxb= auxb.hermano;
        }
        //
        return entropia;        
    }
    
    /** Calcula la entropia de un Atributo */
    public double calcularE(valorAtributo apadre){
        double entropia=0.0;
        double operar;
        valorAtributo auxb;
        //
        auxb= apadre.hijo;
        while(auxb!=null){
            //
            operar= Double.parseDouble(String.valueOf(auxb.getFrec()))/apadre.getFrec();
            entropia= entropia + (operar*log2(operar));
            //
            auxb= auxb.hermano;
        }
        //
        return entropia*-1;        
    }
    
    /** Calcula el logaritmo en base dos */
    public double log2(double value){
        if(value == 0.0) return 0.0;
        return Math.log(value)/Math.log(2);
    }
    
    /** Coloca hijos al Atributo analizado */
    public valorAtributo colocarhijos(valorAtributo auxa, String valor){
        valorAtributo auxn, auxnodo;
        boolean findit;
        //
        auxn= auxa.hijo;
        if(auxn==null){
            auxnodo= new valorAtributo(valor);
            auxa.hijo= auxnodo;
        }else{
            findit=false;                
            while(findit==false){
                if(auxn.getNombre().equals(valor)){
                    findit=true;
                    auxn.incFrec();
                }
                else{
                    if(auxn.hermano==null && findit==false){
                        auxnodo= new valorAtributo(valor);
                        auxn.hermano= auxnodo;
                        findit=true;
                    }else{
                        auxn= auxn.hermano;
                    }
                }
            }
        }                
        //
        return auxa;
    }

    /** Prueba si solo hay una clasificacion */
    public elemento isSameClassification(ClassificationTableModel examples){
        boolean isSame=true;
        int i,n=0;
        String dato, predato="";
        elemento aux=null;
        //
        if(examples.getRowCount()>0)
        predato= examples.getValueAt(0,colT).toString();
        for(i=0;i<examples.getRowCount() && isSame==true;i++){
            dato= examples.getValueAt(i,colT).toString();
            if(dato.equals(predato)){
                n++;
            }else{
                isSame=false;
            }            
        }
        if(n==examples.getRowCount()){
          aux= new elemento(predato);  
          aux.setFrecuence(n);
        }
        //        
        return aux;
    }
    
    /** Escoge el Mayor Valor de la clase Target */
    public elemento valorMayoritario(ClassificationTableModel examples){
        elemento valorMayor= null;
        Vector etiquetas, numetiq;
        //
        boolean isSame=true;
        int i,j,n;
        String dato,detiq;
        etiquetas= valorPerAtrib.getValores(claseT);
        numetiq= new Vector(etiquetas.size());
        for(i=0;i<etiquetas.size();i++){
            numetiq.addElement(0);
        }
        //
        for(i=0;i<examples.getRowCount();i++){
            dato= examples.getValueAt(i,colT).toString();
            isSame=false;
            for(j=0;j<etiquetas.size() && isSame==false;j++){
                detiq= etiquetas.elementAt(j).toString();
                if(detiq.equals(dato)){
                    isSame= true;
                    n= Integer.parseInt(numetiq.elementAt(j).toString());
                    n++; numetiq.remove(j);
                    numetiq.add(j,n);
                }
            }          
        }
        n= Integer.parseInt(numetiq.elementAt(0).toString()); j=0;
        for(i=1;i<numetiq.size();i++){
            if(n< Integer.parseInt(numetiq.elementAt(i).toString())){
                n= Integer.parseInt(numetiq.elementAt(i).toString());
                j=i;
            }            
        }        
        //
        valorMayor= new elemento(etiquetas.elementAt(j).toString(),Integer.parseInt(numetiq.elementAt(j).toString()));
        return valorMayor;
    }
    //
}
