/**
 * MateTableModel.java
 *
 * Created on 13 de julio de 2007, 11:59 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.classification.mate;

import java.util.ArrayList;
import java.util.Vector;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class MateTableModel extends AbstractTableModel {
    
     String[] columnNames = {"Ip type",
                                "Schedule",
                                "Week day",
                                "Duration",
                                "Request amount",
                                "Download size",
                                "Count"};
        private ArrayList sesiones;
        protected TableModel model;
        public ArrayList indTam;

        /**
         * Crea una nueva instancia de la clase ClassificationTableModel.
         *
         * @param sesiones La estructura que sera utilizada para crear el modelo de
         *        la tabla de datos.
         */

        /** Creates a new instance of ClassificationTableModel */
        public MateTableModel(ArrayList sesions) {
            sesiones= sesions;
            fireTableChanged(null);
        }
        
        /**nicamente retornamos el numero de elementos del
        * array de los nombres de las columnas
         */
        public int getColumnCount() {
            return columnNames.length;
        }

        /**retormanos el numero de elementos
        del array de datos
         */
        public int getRowCount() {
            return sesiones.size();
        }

        /**retornamos el elemento indicado
         */
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        /**retornamos el indice de la columna
         */
        public int getColumnIndex(String colname){
            int i, indice=0;
            String aux;
            boolean salir=false;
            //
            for(i=0;i<6 && salir==false;i++){
                aux= columnNames[i];
                if(colname.equals(aux)){
                    salir=true; 
                    i--;
                }
            }
            indice=i;
            //
            return indice;
        }

        /*** Devuelve el objeto en tal fila tal columna
         */
        public Object getValueAt(int row, int col) {
            Object obj = sesiones.get(row);
            String dato="";
            switch(col){
                case 0:
                    dato= ((mateFila) obj).getTipoIP();
                    break;
                case 1:
                    dato= ((mateFila) obj).getHorario();
                    break;
                case 2:
                    dato= ((mateFila) obj).getDiaSemana();
                    break;
                case 3:
                    dato= ((mateFila) obj).getDuracion();
                    break;
                case 4:
                    dato= ((mateFila) obj).getCantPet();
                    break;
                case 5:
                    dato= ((mateFila) obj).getTamDescarga();
                    break;
                case 6:
                    dato= String.valueOf(((mateFila) obj).getConteo());
                    break;
            }
            return dato;
        }
        
        /** Obtiene una fila mate */
        public mateFila getSesionAt(int row){
            return (mateFila) sesiones.get(row);
        }
        
        /** Devuelve una columna en Vector */
        public Vector getValuesColumn(int col){            
            String dato="";
            Vector aux=new Vector();
            //
            for(int i=0; i<sesiones.size();i++){
                Object obj = sesiones.get(i);
                switch(col){
                    case 0:
                        dato= ((mateFila) obj).getTipoIP();
                        break;
                    case 1:
                        dato= ((mateFila) obj).getHorario();
                        break;
                    case 2:
                        dato= ((mateFila) obj).getDiaSemana();
                        break;
                    case 3:
                        dato= ((mateFila) obj).getDuracion();
                        break;
                    case 4:
                        dato= ((mateFila) obj).getCantPet();
                        break;
                    case 5:
                        dato= ((mateFila) obj).getTamDescarga();
                        break;
                    case 6:
                        dato= String.valueOf(((mateFila) obj).getConteo());
                        break;
                }                
                aux.addElement(dato);
            }
            //
            return aux;
        }

        /**
         * Este metodo sirve para determinar el editor predeterminado
         * para cada columna de celdas
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * las celdas de tu tabla sean Editables
         */
        public boolean isCellEditable(int row, int col) {
                return true;
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * los datos de tu tabla cambien
         */        
        
        public void setDatos(ArrayList datosnuevos) {
            this.sesiones = datosnuevos;
            
        }
        
        /** Coloca nuevos nombres a las columnas */
    public void setNomcol(String[] nomcol) {
        this.columnNames = nomcol;
    }    
    
}

