/*
 * HPGTableModel.java
 *
 * Created on 26 de mayo de 2007, 03:19 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.hpg;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class HPGTableModel extends AbstractTableModel {
    
     String[] columnNames = {   "#", //0
                                "ORIGEN NODE", //1
                                "", //2
                                "DESTINE NODE", //3
                                "PROBABILITY" //4
                            };
        private ArrayList producciones;
        /** Decimal format to confidence */
        private DecimalFormat df;
         /** */
        protected TableModel model;

        /**
         * Crea una nueva instancia de la clase ClassificationTableModel.
         *
         * @param sesiones La estructura que sera utilizada para crear el modelo de
         *        la tabla de datos.
         */

        /**
     * Creates a new instance of HPGTableModel
     */
        public HPGTableModel(ArrayList prods) {
            producciones= prods;
            fireTableChanged(null);
            df = new DecimalFormat();
            df.setMaximumFractionDigits(2);
        }
        //nicamente retornamos el numero de elementos del
        //array de los nombres de las columnas
        public int getColumnCount() {
            return columnNames.length;
        }

        //retormanos el numero de elementos
        //del array de datos
        public int getRowCount() {
            return producciones.size();
        }

        //retornamos el elemento indicado
        public String getColumnName(int col) {
            return columnNames[col];
        }
        
        //retornamos el indice de la columna
        public int getColumnIndex(String colname){
            int i, indice=0;
            String aux;
            boolean salir=false;
            //
            for(i=0;i<6 && salir==false;i++){
                aux= columnNames[i];
                if(colname.equals(aux)) salir=true; 
            }
            indice=i;
            //
            return indice;
        }

        //*** Devuelve el objeto en tal fila tal columna
        public Object getValueAt(int rowIndex, int columnIndex) {
            Object obj= producciones.get(rowIndex);
            String dato="";
            if(columnIndex == 0) {
                return rowIndex+1;
            } else if(columnIndex == 1) {
                dato=  String.valueOf(((produccion) obj).getId1());
                if(dato.equals("-1")) dato="START";                
                return dato;
            } else if(columnIndex == 2) {
                dato= " --> ";
                return dato;
            }else if(columnIndex == 3) {
                dato= String.valueOf(((produccion) obj).getId2());
                if(dato.equals("-2")) dato="FINAL";
                return dato;
            }else if(columnIndex == 4) {                
                dato= " WITH PROB " + df.format(((produccion)obj).getProb());
                return dato;
            }       
            return "";
        }
        
        public Vector getValuesColumn(int col){            
            String dato="";
            Vector aux=new Vector();
            //
            for(int i=0; i<producciones.size();i++){
                Object obj = producciones.get(i);
                dato = ((produccion) obj).getId1() + " --> " +
                    ((produccion) obj).getId2() + " WITH PROB " + ((produccion)obj).getProb();                            
                aux.addElement(dato);
            }
            //
            return aux;
        }

        /*
         * Este metodo sirve para determinar el editor predeterminado
         * para cada columna de celdas
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * las celdas de tu tabla sean Editables
         */
        public boolean isCellEditable(int row, int col) {
                return true;
        }

        /*
         * No tienes que implementar este mtodo a menos que
         * los datos de tu tabla cambien
         */        
        
        public void setDatos(ArrayList datosnuevos) {
            this.producciones = datosnuevos;
            
        }
        
    public void setNomcol(String[] nomcol) {
        this.columnNames = nomcol;
    }
        
        
   
    
}
