/*
 * hpg.java
 *
 * Created on 10 de junio de 2007, 09:25 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.hpg;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import Utils.conexion;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class hpg {
    
    // ***
    double alfa; /** Importancia de Inicio */
    int N; /** Valor de N-Grama */
    int totalVisitas, totalInicios;
    // ***
    ArrayList trails;
    ArrayList estados;
    ArrayList producciones;
    // ***
    
    /** Creates a new instance of hpg */
    public hpg() {
        alfa= 0.5;
        N=1;
    }
    
    /** Creates a new instance of hpg */
    public hpg(double a, int n) {
        alfa= a;
        N= n;
    }
    
    // *****
    
    /** LLenar el navigationTrails */
    public void llenarNavigationTrails(int tipoSesion){
        conexion conx;
        navigationTrails trailsTable;        
        String sesion="sesioncomun", columna="nompagvisitadas";
        trails=null;
        trailSession ruta;
        //
        if(tipoSesion==1 || tipoSesion==3){
            sesion="sesioncomun";            
            columna="nompagvisitadas";
        }else if(tipoSesion==2){
            sesion="sesionextendida";
            columna="nompagvisitadas";
        }
        // * inicializo conexion con BDLog
    	// Instanciar conx
    	conx= new conexion();
    	// Abrir conexion a BD logs
    	conx.conectar("polaris","upolaris","ppolaris");
        // * Empezamos a sacar de la base de datos y a colocar en el trails
        String query;
        ResultSet rs;
        try{
            // contar cuantos registros hay en la tabla de sesion 
            query= "SELECT count(*) FROM " + sesion;
            rs= conx.consulta1(query);            
            rs.next();
            //
            int nfilas = rs.getInt(1);
            //System.out.println("filas" + nfilas);
            // sacar registros que hay en la tabla de sesion            
            query= "SELECT id, " + columna + " FROM " + sesion;
            rs= conx.consulta1(query);            
            rs.first();                        
            //            
            int id = 1;
            String transaccion;
            //
            trails= new ArrayList();
            for(int i=0;i<nfilas;i++){
                id= rs.getInt("id");
                transaccion= rs.getString(columna);
                ruta= new trailSession(id,transaccion);
                //
                trails.add(ruta);
                rs.next();
            }
            //            
            System.gc();
            //Chooser.status.setText("Free Memory: " + Runtime.getRuntime().freeMemory()
            //+ " bits");
            conx.cerrarConexion();
            
        } catch (SQLException esql){
            System.out.println("Error en la construccion del DataSet" + esql.getMessage());            
        }
        // *** Inicializo trailsTable
        trailsTable= new navigationTrails(trails);
    }
    
    /** Crear Estados y cant de visitas de los mismos
    //   id=-1 @ Es el estado de inicio - S
    //   id>=0 @ Son estados terminales y no terminales 
    //   id=-2 @ Es el estado Final     - F
     */
    public void crearStatesGrammar(){
        int i, j, idp, k;
        trailSession ruta;
        stateGrammar estadoactual,aux;
        ArrayList transaccion;
        boolean findit;
        //
        totalInicios= trails.size();
        estados= new ArrayList();
        //estadoactual= new stateGrammar(-1,1,1);
        //estados.add(estadoactual);
        if(totalInicios>0){
            //
            totalVisitas= 0;
            for(i=0;i<totalInicios;i++){
                ruta= (trailSession)trails.get(i);
                transaccion= ruta.getPags();
                for(j=0;j<transaccion.size();j++){
                    totalVisitas++;
                    idp= Integer.parseInt(transaccion.get(j).toString());
                    // * Buscarlo a ver si ya esta
                    findit= false;
                    for(k=0; k<estados.size() && findit==false;k++){
                        aux= (stateGrammar) estados.get(k);
                        if(aux.getId()==idp){
                            aux.incNumVisitas();
                            if(j==0) aux.incNumInicios();
                            findit= true;
                            estados.remove(k);
                            estados.add(k,aux);                            
                        }
                    }
                    if(findit==false){ // * Si no esta, lo anado
                        estadoactual= new stateGrammar(idp);
                        estadoactual.incNumVisitas();
                        if(j==0) estadoactual.incNumInicios();
                        estados.add(estadoactual);                        
                    }
                }                
            }            
            //            
            //estadoactual= new stateGrammar(-2,1,1);
            //estados.add(estadoactual);
        }
        //
    }
    
    /** Establecer las producciones de inicio */
    public void crearProduccionesInicio(){
        trailSession session;
        stateGrammar estado;
        produccion prod;
        //
        int i;
        double prob;
        //
        producciones= new ArrayList();
        if(alfa==0){
            // - solo los nodos que fueron inicio de sesion
            for(i=0;i<estados.size();i++){
                estado= (stateGrammar) estados.get(i);
                if(estado.getNumInicios()>0){
                    prod= new produccion(-1,estado.getId(),1);
                    prob= (alfa*estado.getNumVisitas())/totalVisitas;
                    prob= prob + (alfa*estado.getNumInicios())/totalInicios;
                    prod.setProb(prob);
                    producciones.add(prod);
                }
            }          
        }else if(alfa>0){
            // - todos los nodos 
            for(i=0;i<estados.size();i++){
                estado= (stateGrammar) estados.get(i);
                prod= new produccion(-1,estado.getId(),1);
                prob= (alfa*estado.getNumVisitas())/totalVisitas;
                prob= prob + (alfa*estado.getNumInicios())/totalInicios;
                prod.setProb(prob);
                producciones.add(prod);                
            }
        }
    }
    
    /** Establecer las producciones internas */
    public void crearProduccionesInternas(){
        int i,id1,id2,j,k;
        trailSession session;
        stateGrammar estado;
        produccion prod, aux;
        ArrayList urls;
        boolean findit;
        double prob,n_id1;
        //        
        for(i=0;i<trails.size();i++){
            session= (trailSession)trails.get(i);
            urls= session.getPags();
            id1= Integer.parseInt(urls.get(0).toString());
            for(j=1;j<=urls.size();j++){
                if(j==urls.size()){
                    id2= -2;                    
                }else{
                    id2= Integer.parseInt(urls.get(j).toString());    
                }   
                //
                findit=false;
                for(k=0;k<producciones.size() && findit==false;k++){
                    aux= (produccion)producciones.get(k);
                    if(id1==aux.getId1() && id2==aux.getId2()){
                        findit=true;
                        aux.incPasos();
                        n_id1=this.vecesId1(id1);
                        prob= aux.getPasos()/n_id1;
                        aux.setProb(prob);
                        producciones.remove(k);
                        producciones.add(k,aux);                       
                        //
                    }
                }
                if(findit==false){
                    if(id2==-2) prod= new produccion(id1,id2,3);
                    else prod= new produccion(id1,id2,2);
                    n_id1=this.vecesId1(id1);                        
                    prob= prod.getPasos()/n_id1;
                    prod.setProb(prob);                    
                    producciones.add(prod); 
                    //                    
                }
                id1=id2;
            }            
        }
    }
    
    public int vecesId1(int id1){
        int n=0,i;
        stateGrammar estado;
        //
        for(i=0;i<estados.size();i++){
            estado= (stateGrammar) estados.get(i);
            if(estado.getId()==id1){
                n= estado.getNumVisitas();
            }
        }
        //
        return n;
    }
    
    /** Devuelve producciones */
    public ArrayList getProducciones(){
        return producciones;
    }
    
    // *****

} // *************************

