/*
 * produccion.java
 *
 * Created on 10 de junio de 2007, 09:24 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package algorithm.hpg;

import java.text.DecimalFormat;

/**
 *
 * @author Proyecto *** Polaris *** Johana
 */
public class produccion {
    
    // ***
    int id1;    /** id del estado origen  */
    int id2;    /** id del estado final */
    double p;   /** probabilidad de que pase por esta produccion (flecha) */
    int tipo;   /** tipo de produccion que sea... 
                //   1 - start prod - produccion inicial 
                //   2 - transitive prod - produccion interior
                //   3 - final prod - produccion final */
    int nPasos;
    // ***
    
    /** Creates a new instance of produccion */
    public produccion(int pag1, int pag2) {
        id1= pag1;
        id2= pag2;
        p= 0.0;
        tipo=0;
        nPasos=1;
    }
    
    /** Creates a new instance of produccion */
    public produccion(int pag1, int pag2, int t) {
        id1= pag1;
        id2= pag2;
        p= 0.0;
        tipo= t;
        nPasos=1;
    }
    
    public void setProb(double prob){
        p= prob;
    }
    
    public void calcProb(int ni, int nt){
        if(nt!=0) p= ni/nt;
    }
    
    public void setPasos(int n){
        nPasos= n;
    }
    
    public void incPasos(){
        nPasos++;
    }
    
    public int getPasos(){
        return nPasos;
    }
    
    public int getId1(){
        return id1;
    }   
    
    public int getId2(){
        return id2;
    }
    
    public double getProb(){
        return p;
    }
    
    public int getTipo(){
        return tipo;
    }
    
    /** Coloca las producciones en una tabla de un archivo html */
    public String toString(){
        DecimalFormat df= new DecimalFormat();
            df.setMaximumFractionDigits(2);
        String salida="";
        //
        salida += "\n <td> " ;
        salida += "\n        <div align='center'>";
        salida += "\n         <span class='Estilo5'>";
        if(this.getId1() == -1) salida += "START";
        else salida += this.getId1();
        salida += "\n         </span>";
        salida += "\n </div>";
        salida += "</td> " ;
        //
        salida += "\n <td> " ;
        salida += "-->";
        salida += "</td> " ;
        //
        salida += "\n <td> " ;
        salida += "\n        <div align='center'>";
        salida += "\n         <span class='Estilo5'>";
        if(this.getId2() == -2) salida += "FINALE";
        else salida += this.getId2();
        salida += "\n         </span>";
        salida += "\n </div>";
        salida += "</td> " ;
        //
        salida += "\n <td> " ;
        salida += "\n        <div align='center'>";
        salida += "\n         <span class='Estilo5'>";
        salida += df.format(this.getProb());
        salida += "\n         </span>";
        salida += "\n </div>";
        salida += "</td> " ;                
        //
        return salida;
   }
    
} // **********************
