/**ESTE ARCHIVO ES BASE PARA LA EJECUCION DEL D&D
dependiendo del valor de la cadena asigna un nodo*/

package dnd;

import javax.swing.*;
import workspace.Association.algorithms.AprioriNode;
import workspace.Main_Set.Area;
import workspace.Classification.algorithms.C45Node;
import workspace.Classification.algorithms.CBANode;
import workspace.Clustering.ClusteringNode;
import workspace.Association.algorithms.EquipAssoNode;
import workspace.Association.algorithms.FpTreeNode;
import workspace.HPG.HPGNode;
import workspace.Prepro.IntervalNode;
import workspace.Classification.algorithms.MateTreeNode;
import workspace.Prepro.FilterNode;
import workspace.Source.SelectSourceNode;
import workspace.Views.TableViewNode;
import workspace.Views.TreeViewNode;
import workspace.Prepro.UmbralNode;
import workspace.Views.BFSTreeNode;
import workspace.Views.GrammarViewNode;
import workspace.Views.HPGTableNode;
import workspace.Views.JTreeViewNode;
import workspace.Views.RulesViewNode;
import workspace.Views.StatViewNode;
import workspace.Views.WekaViewNode;

/**extiende de la otra clase del paquete dnd*/
public class AreaTransferHandler extends StringTransferHandler {       
    /**siempre retorna cadena vacia porque su funcion principal es 
    recibir cadenas y realizar comparaciones*/
    //public boolean banArrastre;
    protected String exportString(JComponent c) {
        return "";
    }
    /**con esta badera se permite que primero solo se pueda arrastrar el select source*/
  
    /**recibe las cadenas*/
    protected void importString(JComponent c, String str) {
        /**asigna al objeto a tipo Area un objeto c forzado al tipo Area*/
        Area a = (Area)c;
        if(str.equals("Web Server")){ a.setBanArrastre(true);}
        /**realiza la comparacion de cadenas y dependiendo de su valor crea un nuevo nodo*/
        /**anadiendolo al objeto a*/
        
        if(str.equals("Web Server")){
            a.addNodo(new SelectSourceNode(a.getMousePosition()));           
            /**repaint sirve para actualizar los pixeles*/
            a.repaint();
           
        } else if(str.equals("Inter.Session") && a.isBanArrastre() == true){                     
            a.addNodo(new IntervalNode(a.getMousePosition()));
            a.repaint();
        } else if(str.equals("GAP Session" ) && a.isBanArrastre() == true){
            a.addNodo(new UmbralNode(a.getMousePosition()));
            a.repaint();
        } else if(str.equals("Discretize") && a.isBanArrastre() == true){
            a.addNodo(new FilterNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("Apriori") && a.isBanArrastre() == true){
            a.addNodo(new AprioriNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("EquipAsso") && a.isBanArrastre() == true){
            a.addNodo(new EquipAssoNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("C 4.5") && a.isBanArrastre() == true){
            a.addNodo(new C45Node(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("MateTree") && a.isBanArrastre() == true){
            a.addNodo(new MateTreeNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("CBA")){
            a.addNodo(new CBANode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("k-medias")){
            a.addNodo(new ClusteringNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("HPG") && a.isBanArrastre() == true){
            a.addNodo(new HPGNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("FpTree") && a.isBanArrastre() == true){
            a.addNodo(new FpTreeNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("Table") && a.isBanArrastre() == true){
            a.addNodo(new TableViewNode(a.getMousePosition()));
            a.repaint();              
        } else if (str.equals("Tree") && a.isBanArrastre() == true){
            a.addNodo(new TreeViewNode(a.getMousePosition()));
            a.repaint();         
        } else if (str.equals("Stat") && a.isBanArrastre() == true){
            a.addNodo(new StatViewNode(a.getMousePosition()));
            a.repaint();        
        }  else if (str.equals("Grammar") && a.isBanArrastre() == true){
            a.addNodo(new GrammarViewNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("JTree") && a.isBanArrastre() == true){
            a.addNodo(new JTreeViewNode(a.getMousePosition()));
            a.repaint();
        }  else if (str.equals("Weka") && a.isBanArrastre() == true){
            a.addNodo(new WekaViewNode(a.getMousePosition()));
            a.repaint();
        } else if (str.equals("Rules") && a.isBanArrastre() == true){
            a.addNodo(new RulesViewNode(a.getMousePosition()));
            a.repaint();
        }  else if (str.equals("HPG Table") && a.isBanArrastre() == true){
            a.addNodo(new HPGTableNode(a.getMousePosition()));
            a.repaint();
        } 
        else if (str.equals("BFSTree") && a.isBanArrastre() == true){
            a.addNodo(new BFSTreeNode(a.getMousePosition()));
            a.repaint();
        }      
    }
    
    protected void cleanup(JComponent c, boolean remove) {
    }

//    public boolean isBanArrastre() {
//        return banArrastre;
//    }
//
//    public void setBanArrastre(boolean banArrastre) {
//        this.banArrastre = banArrastre;
//    }
//    
}

