/** Archivo encargado de recibir los nodos Johanna */

package grammar;

import algorithm.hpg.produccion;
import java.awt.GraphicsEnvironment;
import java.awt.Image;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;

public class Window extends javax.swing.JFrame {
    
    private DefaultListModel model;
    List<Nodo> nodos;
    ArrayList npags;
    
    
    public Window(ArrayList producciones, String nomlog) {
        String nodito;
        this.setIconImage(this.getImage("/media/appicon.png"));
        this.setTitle("HPG - Hypertext Probabilistic Grammar of: " + nomlog);
        //
        initComponents();
        List<produccion> nodosj = producciones;
        
        /** la lista nodo casteada a Nodo recibe el parametro del metodo construcTree*/
        /** del archivo NodeUtils*/
        nodos = NodeUtils.constructTree(nodosj);
        /** el panel recibe la lista nodos*/
        this.treePanel1.setNodos(nodos);
        /** modelo del JList lstNodos*/
        model = new DefaultListModel();
        npags= this.nomPaginas();
        /** el identificador de cada nodo es anadido */
        model.addElement("-1 .:. START");
        for (int i = 0; i < npags.size(); i++) {
            if(i<10){ nodito= String.valueOf(i) + "   :: " + npags.get(i).toString(); } else{ nodito= String.valueOf(i) + "  :: " + npags.get(i).toString(); }
            model.addElement(nodito);
            //model.addElement(nodos.get(i));
        }
        model.addElement("-2 .:. FINALE");
        this.lstNodos.setModel(model);
        /**Maximiza la ventana*/
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
        this.setExtendedState(this.getExtendedState() | this.MAXIMIZED_BOTH);
    }
    
    public ArrayList nomPaginas(){
        colocarnom cnom= new colocarnom();
        return cnom.getLisPags();
    }
    
    public Nodo findEnNodos(int clave){
        Nodo n=null;
        boolean find=false;
        //
        for(int i=0; i<nodos.size() && find==false;i++){
            n= (Nodo) nodos.get(i);
            if(clave==n.getId()) find= true;
        }
        //
        return n;
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane3 = new javax.swing.JScrollPane();
        lbsStatus = new javax.swing.JLabel();
        pnlNodes = new javax.swing.JPanel();
        btnRadius = new javax.swing.JButton();
        txtRadius = new javax.swing.JTextField();
        lblRadius = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstNodos = new javax.swing.JList();
        pnlDraw = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        treePanel1 = new grammar.TreePanel();
        conv = new javax.swing.JScrollPane();
        pnlEtiq = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();

        btnRadius.setText("Accept");
        btnRadius.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnRadiusActionPerformed(evt);
            }
        });

        txtRadius.setText("50");

        lblRadius.setText("Radius:");

        jLabel13.setText("Select Node:");

        lstNodos.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        lstNodos.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lstNodosValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(lstNodos);

        javax.swing.GroupLayout pnlNodesLayout = new javax.swing.GroupLayout(pnlNodes);
        pnlNodes.setLayout(pnlNodesLayout);
        pnlNodesLayout.setHorizontalGroup(
            pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlNodesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlNodesLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblRadius, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtRadius, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnRadius))
                    .addComponent(jLabel13)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 256, Short.MAX_VALUE))
                .addContainerGap())
        );
        pnlNodesLayout.setVerticalGroup(
            pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlNodesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlNodesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtRadius, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnRadius)
                    .addComponent(lblRadius, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 490, Short.MAX_VALUE)
                .addContainerGap())
        );

        jLabel12.setText("Grammar View:");

        jScrollPane2.setViewportView(treePanel1);

        jLabel3.setText("Inactive Connection:");

        jLabel2.setBackground(new java.awt.Color(204, 204, 255));
        jLabel2.setForeground(new java.awt.Color(204, 204, 255));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel2.setMaximumSize(new java.awt.Dimension(20, 20));
        jLabel2.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel2.setOpaque(true);
        jLabel2.setPreferredSize(new java.awt.Dimension(20, 20));

        jLabel5.setText("       Current Node:");

        jLabel4.setBackground(new java.awt.Color(255, 0, 0));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel4.setMaximumSize(new java.awt.Dimension(20, 20));
        jLabel4.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel4.setOpaque(true);
        jLabel4.setPreferredSize(new java.awt.Dimension(20, 20));

        jLabel9.setText("       Probability: ");

        jLabel8.setBackground(new java.awt.Color(0, 102, 204));
        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel8.setMaximumSize(new java.awt.Dimension(20, 20));
        jLabel8.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel8.setOpaque(true);
        jLabel8.setPreferredSize(new java.awt.Dimension(20, 20));

        jLabel7.setText("       Out Connections:");

        jLabel6.setBackground(new java.awt.Color(102, 204, 255));
        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel6.setMaximumSize(new java.awt.Dimension(20, 20));
        jLabel6.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel6.setOpaque(true);
        jLabel6.setPreferredSize(new java.awt.Dimension(20, 20));

        jLabel10.setText("       In Connections:");

        jLabel11.setBackground(new java.awt.Color(255, 255, 51));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel11.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel11.setMaximumSize(new java.awt.Dimension(20, 20));
        jLabel11.setMinimumSize(new java.awt.Dimension(20, 20));
        jLabel11.setOpaque(true);
        jLabel11.setPreferredSize(new java.awt.Dimension(20, 20));

        javax.swing.GroupLayout pnlEtiqLayout = new javax.swing.GroupLayout(pnlEtiq);
        pnlEtiq.setLayout(pnlEtiqLayout);
        pnlEtiqLayout.setHorizontalGroup(
            pnlEtiqLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlEtiqLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(63, 63, 63))
        );
        pnlEtiqLayout.setVerticalGroup(
            pnlEtiqLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlEtiqLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlEtiqLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel11, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel8, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel9, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel10, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        conv.setViewportView(pnlEtiq);

        javax.swing.GroupLayout pnlDrawLayout = new javax.swing.GroupLayout(pnlDraw);
        pnlDraw.setLayout(pnlDrawLayout);
        pnlDrawLayout.setHorizontalGroup(
            pnlDrawLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlDrawLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlDrawLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 732, Short.MAX_VALUE)
                    .addComponent(conv, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 732, Short.MAX_VALUE)
                    .addComponent(jLabel12, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        pnlDrawLayout.setVerticalGroup(
            pnlDrawLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlDrawLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel12)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 479, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(conv, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lbsStatus, javax.swing.GroupLayout.DEFAULT_SIZE, 1034, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(pnlDraw, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pnlNodes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnlDraw, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlNodes, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbsStatus, javax.swing.GroupLayout.PREFERRED_SIZE, 17, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void btnRadiusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnRadiusActionPerformed
        int rad;
        try {
            rad = Integer.parseInt(this.txtRadius.getText());
            if (rad<50 || rad>500) {
                this.lbsStatus.setText("50 > Radius < 500");
            } else  {
                this.treePanel1.setRadio1(Integer.parseInt(this.txtRadius.getText()));                
                this.treePanel1.setNodos(this.treePanel1.getNodos());
            }
        } catch (NumberFormatException ex) {
            //ex.printStackTrace();
            this.lbsStatus.setText("Only nubers in this range: 100 > Radius < 500");
        }
        
        
    }//GEN-LAST:event_btnRadiusActionPerformed
    
    private void lstNodosValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lstNodosValueChanged
        Nodo n=null;
        int num, fin;
        /** este evento propio del Jlist se encarga de que el nodo que se
         * encuentre seleccionado en la lista se marque en el panel*/
        String dato= model.getElementAt(this.lstNodos.getSelectedIndex()).toString();
        fin= dato.indexOf(' ');
        String nnom= dato.substring(0,fin);
        num= Integer.parseInt(nnom);
//        if(dato.equals("START")){
//            num=-1;
//        }else if(dato.equals("FINALE")){
//            num=-2;
//        }else{
//            num=npags.indexOf(dato);
//        }
        n= this.findEnNodos(num);
        this.treePanel1.setSelectedNodo(n);
        
    }//GEN-LAST:event_lstNodosValueChanged
    
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    
    
    
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new Window().setVisible(true);
//            }
//        });
//    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnRadius;
    private javax.swing.JScrollPane conv;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel lblRadius;
    private javax.swing.JLabel lbsStatus;
    private javax.swing.JList lstNodos;
    private javax.swing.JPanel pnlDraw;
    private javax.swing.JPanel pnlEtiq;
    private javax.swing.JPanel pnlNodes;
    private grammar.TreePanel treePanel1;
    private javax.swing.JTextField txtRadius;
    // End of variables declaration//GEN-END:variables
    
}
