//crear grafico actividad estadistica por fecha
package polaris3.Chart;

import polaris3.DataAcces.MiConexion;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.Statistics.ActividadEstadistica.ConfGraficoAE;
import polaris3.Statistics.ActividadEstadistica.ConfGraficoActDia;
import polaris3.Statistics.ActividadEstadistica.CrearGraficos;


//clase para cambiar la apariencia de las tablas
public class GraficoActividadDia extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoCorriendo;
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    
    ConfGraficoActDia confGrafico;
    ConfGraficoAE confTipoGrafico;
    
    //tipo de grafico
    static boolean graficoBarras=false;
    static boolean graficoLinea=false;
    
    //series
    static boolean serieHits=false;
    static boolean seriePaginasVistas=false;
    static boolean serieVisitantes=false;
    static boolean serieTransferencia=false;
    
    //int tamaoArreglos=0;//para definir el tamaño de los arreglos
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    //arreglos para crear el grafico
    Vector vectorDias = new Vector();
    Vector vectorHits = new Vector();
    Vector vectorPaginasVistas = new Vector();
    Vector vectorVisitantes= new Vector();
    Vector vectorTransferencia = new Vector();
    
    Vector vectorValores = new Vector();//valores
    Vector vectorSeries = new Vector();//series: hits, paginas vistas, visitantes y/o transferencia
    Vector vectorTiempos = new Vector();//fecha, dia u hora
    
    public GraficoActividadDia(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        CargarConfiguracion();
        CrearTablaActividadFecha();//crear tabla en la bd
        CrearTabla();
        //CrearDatos();
        nodoCorriendo=true;
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    private void CrearTabla(){
        String[] nombresColumnas = {"DAY", "HITS","PAGE VIEWS","VISITORS","TRANSFER (KB)"};
        Object[][] datos=null ;
        miModelo = new DefaultTableModel(datos, nombresColumnas);
        //__LLENAR DATOS EN LA TABLA___________________________________________
        CargarDatosGrafico();
        //_____________________________________________________________________
        miTabla.setModel(miModelo); 
        
        //modificar ancho de columnas y centrar
        TableColumn miColumna;
        
        for (int i = 0; i < 5; i++) {
            miColumna = miTabla.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(20); //COLUMNA FECHA
	    if(i == 1) miColumna.setPreferredWidth(20); //COLUMNA HITS
            if(i == 2) miColumna.setPreferredWidth(20); //COLUMNA PAGE VIEWS
	    if(i == 3) miColumna.setPreferredWidth(20); //COLUMNA VISITOR
        }   
        miTabla.setDefaultRenderer (Object.class, new MiRenderAD());
    }
    
    public void CargarTipoGrafico(){
        graficoBarras = confTipoGrafico.isGraficoBarras();
        graficoLinea = confTipoGrafico.isGraficoLinea();
        System.out.println("barras" + graficoBarras);
        System.out.println("linea" + graficoLinea);
    }
    private void CargarConfiguracion(){//cargar configuracion del grafico
        graficoBarras = confGrafico.isGraficoBarras();
        graficoLinea = confGrafico.isGraficoLinea();
        
        serieHits = confGrafico.isSerieHits();
        seriePaginasVistas = confGrafico.isSeriePaginasVistas();
        serieVisitantes = confGrafico.isSerieVisitantes();
        serieTransferencia = confGrafico.isSerieTransferencia();
    }
    
    private void CrearTablaActividadFecha(){//crear tabla en la bd
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT crear_tabla_actividad_diaria()");
            System.out.println("Se ejecuto la funcion crear_tabla_actividad_diaria(). CrearActiviadDia.java"); 
 
            miResulSet.close();
            miStatement.close();
        }
        catch (Exception e){
            System.out.println("Error al ejecutar lafuncion crear_tabla_actividad_diaria(). CrearActiviadDia.java");
            System.out.println(e.getMessage());
        }   
    }
    
    private void CargarDatosGrafico(){//cargar datosdesde la bs
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;

        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT dia,hits,no_paginas_vistas,no_visitantes,transferencia FROM actividad_diaria ORDER BY id_dia ");
            while (miResulSet.next()){
                Object [] fila = new Object[5]; // Hay 5 columnas en la tabla

                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/1000;//redondear
                
                //Se rellena cada posición del array con una de las columnas de la tabla en base de datos.
                for (int i=0;i<4;i++)//columna 0,1,2,3
                    fila[i] = miResulSet.getString(i+1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.
                fila[4]=miTransfrencia;//columna 4: transferncia en kb
                // Se añade al modelo la fila completa.
                miModelo.addRow(fila);
                vectorDias.addElement(miResulSet.getString("dia"));
                vectorHits.addElement(miResulSet.getInt("hits"));
                vectorPaginasVistas.addElement(miResulSet.getInt("no_paginas_vistas"));
                vectorVisitantes.addElement(miResulSet.getInt("no_visitantes"));
                vectorTransferencia.addElement(miTransfrencia);
                //vectorTransferencia.addElement(miResulSet.getInt("transferencia"));
            }

        }catch (Exception e){
            System.out.println("Problemas para crear grafico Actividad por fecha: "+e.getMessage());
        }
    }
    
    public void CrearDatos(){//crear datos para construir graficoi
        
        if(serieHits==true && seriePaginasVistas==true){//grafico de dos series (hits y paginas vistas)
            for(int i=0;i<vectorDias.size();i++){
                vectorTiempos.addElement(vectorDias.elementAt(i).toString());//fechas para serie hits
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
                vectorSeries.addElement("Hits");
            }
            for(int i=0;i<vectorDias.size();i++){//fechas para serie paginas vistas
                vectorTiempos.addElement(vectorDias.elementAt(i).toString());//fechas para serie hits
                vectorValores.addElement(Integer.parseInt(vectorPaginasVistas.elementAt(i).toString()));//hits
                vectorSeries.addElement("Page Views");
            }
            CrearGrafico("Day", "Request Amount");
        }
        
        if(serieHits==true && seriePaginasVistas==false){//grafico de una serie (hits)
            for(int i=0;i<vectorDias.size();i++){
                vectorTiempos.addElement(vectorDias.elementAt(i).toString());//fechas para serie hits
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
                vectorSeries.addElement("Hits");
            }
            CrearGrafico("Day", "Request Amount");
        }
        
        if(seriePaginasVistas==true && serieHits==false){//grafico de una serie (paginas vistas)
            for(int i=0;i<vectorDias.size();i++){
                vectorTiempos.addElement(vectorDias.elementAt(i).toString());//fechas para serie hits
                vectorValores.addElement(Integer.parseInt(vectorPaginasVistas.elementAt(i).toString()));//hits
                vectorSeries.addElement("Page Views");
            }
        }
        
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorDias.size();i++){
                vectorTiempos.addElement(vectorDias.elementAt(i).toString());//fechas para serie hits
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
                vectorSeries.addElement("Visitors");
            }
            CrearGrafico("Day", "Visitors Amount");
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorDias.size();i++){
                vectorTiempos.addElement(vectorDias.elementAt(i).toString());//fechas para serie hits
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
                vectorSeries.addElement("Transfer");
            }
            CrearGrafico("Day", "Transfer (KB)");
        }
    }
    
    private void CrearGrafico(String tituloX, String tituloY){//crear grafico en la clase CrearGraficos.java
        
        String tipoGrafico="";
        if(graficoBarras==true)
            tipoGrafico="barras";
        if(graficoLinea==true)
            tipoGrafico="linea";
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = miJpanel.getSize();//toma el tamaño del contenedor
        String[] datos = {"Activity Statistics by Day",tituloX,tituloY};
        migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorTiempos, datos,tipoGrafico);
        //se crea un jlabel para colocar el grafico
        miJpanel.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        miJpanel.add(chartPanel);

        miJpanel.repaint();
        this.repaint();
    }
    
    
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        miTabla = new javax.swing.JTable();
        miJpanel = new javax.swing.JPanel();
        jSeparator1 = new javax.swing.JSeparator();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Activity Statistics by Day");
        setAlwaysOnTop(true);

        miTabla.setBackground(new java.awt.Color(153, 153, 255));
        miTabla.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(miTabla);

        miJpanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));

        javax.swing.GroupLayout miJpanelLayout = new javax.swing.GroupLayout(miJpanel);
        miJpanel.setLayout(miJpanelLayout);
        miJpanelLayout.setHorizontalGroup(
            miJpanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 623, Short.MAX_VALUE)
        );
        miJpanelLayout.setVerticalGroup(
            miJpanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 274, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 625, Short.MAX_VALUE)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 625, Short.MAX_VALUE)
                    .addComponent(miJpanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(miJpanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoActividadDia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoActividadDia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoActividadDia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoActividadDia.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoActividadDia dialog = new GraficoActividadDia(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JPanel miJpanel;
    private javax.swing.JTable miTabla;
    // End of variables declaration//GEN-END:variables
}
class MiRenderAD extends DefaultTableCellRenderer{
    
    Color currColor=Color.white;  
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column)
    {
        super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
        this.setOpaque(true);
        table.setShowGrid(true);
        
        //cambiar fuente de cabeseras
        JTableHeader th = table.getTableHeader(); 
        Font fuente = new Font("Verdana", Font.BOLD, 12); 
        th.setFont(fuente); 
        //th.setBackground(new Color(153,153,255));
        
        //alternar color de filas
        if(row%2==0) {                              
            currColor=Color.white;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(table.getSelectionForeground());  
            super.setBackground(table.getSelectionBackground());  
        } else {  
            super.setForeground(Color.black);     
            super.setBackground(currColor);  
        }                         
        setFont(table.getFont());                                  
        setValue(value);  
        
        //alinear columnas
        super.setHorizontalAlignment(SwingConstants.LEFT);
     
        //resisables
        table.getColumnModel().getColumn(0).setResizable(false);
        table.getColumnModel().getColumn(1).setResizable(false);
        table.getColumnModel().getColumn(2).setResizable(false);
        table.getColumnModel().getColumn(3).setResizable(false);
        //table.getColumnModel().getColumn(4).setResizable(false);
        return this;
   }
}
