
package polaris3.Chart;

import polaris3.Statistics.uaTipos.*;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.RefBuscadores.ConfGraficoBuscadores;
import polaris3.Statistics.RefBuscadores.CrearGraficos;


public class GraficoBuscadores extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoBuscadores confGraficoBuscadores;
    ConfTipoGrafico confTipoGrafico;
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    
    //tipo grafico
    boolean graficoBarras=false;
    boolean graficoPastel=false;
    
    
    //vectores para graficos
    Vector vectorSistemaOperativo=new Vector();//tipo de user agent
    Vector vectorHits=new Vector();
    Vector vectorVisitantes=new Vector();
    Vector vectorTransferencia=new Vector();
    Vector vectorValores=new Vector();
    Vector vectorSeries=new Vector();
    //modelos par los jlist
    DefaultListModel modeloListaExtensiones=new DefaultListModel();
    DefaultListModel modeloListaNombreAchivo=new DefaultListModel();
    
    public GraficoBuscadores(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        cargaConfiguracion();
        Configurar();
        CargarDatosGrafico();
             
        nodoCorriendo=true;
    }
     public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    
    private void cargaConfiguracion(){
        serieHits=confGraficoBuscadores.isSerieHits();
        serieTransferencia=confGraficoBuscadores.isSerieTransferencia();
        serieVisitantes=confGraficoBuscadores.isSerieVisitantes();
        graficoBarras=confTipoGrafico.isGraficoBarras();
        graficoPastel=confTipoGrafico.isGraficoPastel();       
        ImprimirConfiguracion();
    }
    
    private void Configurar(){             
        if(serieHits==true) strSerie="hits";
        if(serieVisitantes==true) strSerie="visitantes";
        if(serieTransferencia==true) strSerie="transferencia";
    }
    
    //graficar extensiones
    private void CargarDatosGrafico(){//cargar datosdesde la bs
        
        String miConsulta="";
        
        miConsulta="SELECT buscador,hits,visitantes,transferencia FROM est_buscadores ORDER BY "+ strSerie + " desc";
        
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            int i=0;//obtener los dies requeste mas hits, visitados o transfer KB
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next() && i<15){
                
                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                vectorSistemaOperativo.addElement(miResulSet.getString("buscador"));
                vectorHits.addElement(miResulSet.getInt("hits"));
                vectorVisitantes.addElement(miResulSet.getInt("visitantes"));
                vectorTransferencia.addElement(miTransfrencia);
                i++;                 
            }
            //CrearDatosGrafico();
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  grafico clase GraficoBuscadores.java: "+e.getMessage());
        }
        if(graficoBarras==true)
            CrearDatosGraficoBarras();
        if(graficoPastel==true)
            CrearDatosGraficoPastel();
    }
    
     public void CrearDatosGraficoBarras(){//crear datos para construir grafico
        
        
        if(serieHits==true ){//grafico de una serie (hits)
            for(int i=0;i<vectorSistemaOperativo.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
                vectorSeries.addElement("Hits");
            }
            CrearGraficoBarras("Search Engine", "Hits Amount");
        }
               
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorSistemaOperativo.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
                vectorSeries.addElement("Visitors");
            }
            CrearGraficoBarras("Search Engine", "Visitors Amount");
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorSistemaOperativo.size();i++){
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
                vectorSeries.addElement("Transfer");
            }
            CrearGraficoBarras("Search Engine", "Transfer (KB)");
        }
    }
     
     public void CrearGraficoBarras(String tituloX, String tituloY){//crear grafico en la clase CrearGraficos.java
        
        String tipoGrafico="";
        tipoGrafico="barras";
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = miPanel.getSize();//toma el tamaño del contenedor
        String[] datos = {"SEARCH ENGINES",tituloX,tituloY};
        migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorSistemaOperativo, datos,tipoGrafico);
        //se crea un jlabel para colocar el grafico
        miPanel.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        miPanel.add(chartPanel);

        miPanel.repaint();
        this.repaint();
    }
    
     public void CrearDatosGraficoPastel(){//crear datos para construir grafico extensiones
        
        if(serieHits==true){//grafico de una serie (hits)
            for(int i=0;i<vectorSistemaOperativo.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorHitsExtensiones.elementAt(i).toString()+" Hits", i);
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
            }
            strSerie="Hits";
        }
        
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorSistemaOperativo.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorVisitantesExtensiones.elementAt(i).toString()+" Visitors", i);
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
            }
            strSerie="Visitors";
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorSistemaOperativo.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorTransferenciaExtensiones.elementAt(i).toString()+" KB", i);
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
            }
            strSerie="KB";
        }
        CrearGraficoPastel();
    }
    
     private void CrearGraficoPastel(){//crear grafico en la clase CrearGraficos.java
        //grafico piechart
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = miPanel.getSize();//toma el tamaño del contenedor

        migrafico.crear_grafico_pieChart(d, vectorSistemaOperativo, vectorValores,"SEARCH ENGINES",strSerie);
        //se crea un jlabel para colocar el grafico
        
        miPanel.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        miPanel.add(chartPanel);

        miPanel.repaint();
        this.repaint();
    }
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTansferencis: "+serieTransferencia);
      
        System.out.println("---------------------------------------------------");
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        miPanel = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Search Engines");
        setAlwaysOnTop(true);

        miPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout miPanelLayout = new javax.swing.GroupLayout(miPanel);
        miPanel.setLayout(miPanelLayout);
        miPanelLayout.setHorizontalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 744, Short.MAX_VALUE)
        );
        miPanelLayout.setVerticalGroup(
            miPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 486, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(miPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(miPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoBuscadores.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoBuscadores.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoBuscadores.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoBuscadores.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoBuscadores dialog = new GraficoBuscadores(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel miPanel;
    // End of variables declaration//GEN-END:variables
}
class MyCellRenderer2 extends  DefaultListCellRenderer {
        public MyCellRenderer2() {
            setOpaque(true);
        }
        Color currColor=Color.white;  
        public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
        if(index%2==0) {                              
            currColor=Color.LIGHT_GRAY;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(list.getSelectionForeground());  
            super.setBackground(list.getSelectionBackground());  
        } else {  
            super.setForeground(Color.BLACK);     
            super.setBackground(currColor);  
        }           
        setFont(list.getFont());                                  
            return this;
        }
    }

//clase para cambiar la apariencia de las tablas
class MiRenderAF2 extends DefaultTableCellRenderer{
    
    Color currColor=Color.white;  
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column)
    {
        super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
        this.setOpaque(true);
        table.setShowGrid(true);
        
        //cambiar fuente de cabeseras
        JTableHeader th = table.getTableHeader(); 
        Font fuente = new Font("Verdana", Font.BOLD, 12); 
        th.setFont(fuente); 
       // th.setBackground(new Color(153,153,255));
        
        //alternar color de filas
        if(row%2==0) {                              
            currColor=Color.white;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(table.getSelectionForeground());  
            super.setBackground(table.getSelectionBackground());  
        } else {  
            super.setForeground(Color.black);     
            super.setBackground(currColor);  
        }                         
        setFont(table.getFont());                                  
        setValue(value);  
        
        //alinear columnas
        super.setHorizontalAlignment(SwingConstants.LEFT);
     
        //resisables
       // table.getColumnModel().getColumn(0).setResizable(false);
        //table.getColumnModel().getColumn(1).setResizable(false);
        //table.getColumnModel().getColumn(2).setResizable(false);
        //table.getColumnModel().getColumn(3).setResizable(false);
        //table.getColumnModel().getColumn(4).setResizable(false);
        return this;
   }
}