
package polaris3.Chart;

import polaris3.Statistics.EstadisticaAccesos.*;
import java.awt.Dimension;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.CodigosHttp.CrearGraficos;

public class GraficoCodigosHttp extends javax.swing.JDialog {

    public Nodo n=null;
    boolean nodoCorriendo;
    
    ConfGraficoTipoArchivos confGraficoTipoArchivo;
    
  
     //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    //vectores para piechart
    Vector vectorCodigoHttp=new Vector();
    Vector vectorHitsCodigoHttp=new Vector();
    Vector vectorValoresCodigoHttp=new Vector();
    
    //vectores para CODIGOSDE ERROR
    Vector vectorErrores=new Vector();
    Vector vectorHitsErrores=new Vector();
    Vector vectorValoresErrores=new Vector();
    
    public GraficoCodigosHttp(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
         this.setIconImage(this.getImage("/media/star.png"));
        CargarDatosGraficoCodigosHttp();
        CrearDatosCodigosHttp();
        
        CargarDatosGraficoErrores();
        CrearDatosErores();
        
        nodoCorriendo=true;
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanelCodigoHttp = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanelErrores = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Http Status Codes");
        setAlwaysOnTop(true);

        javax.swing.GroupLayout jPanelCodigoHttpLayout = new javax.swing.GroupLayout(jPanelCodigoHttp);
        jPanelCodigoHttp.setLayout(jPanelCodigoHttpLayout);
        jPanelCodigoHttpLayout.setHorizontalGroup(
            jPanelCodigoHttpLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 712, Short.MAX_VALUE)
        );
        jPanelCodigoHttpLayout.setVerticalGroup(
            jPanelCodigoHttpLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 350, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("HTTP STATUS CODES", jPanelCodigoHttp);

        javax.swing.GroupLayout jPanelErroresLayout = new javax.swing.GroupLayout(jPanelErrores);
        jPanelErrores.setLayout(jPanelErroresLayout);
        jPanelErroresLayout.setHorizontalGroup(
            jPanelErroresLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 712, Short.MAX_VALUE)
        );
        jPanelErroresLayout.setVerticalGroup(
            jPanelErroresLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 350, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanelErrores, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanelErrores, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("ERROR CODES", jPanel1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 717, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 378, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void CargarDatosGraficoCodigosHttp(){//cargar datosdesde la bs
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
 
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT codigo_http ||' - '|| tipo as mi_codigo ,hits FROM estadisticas_codigoshttp ORDER BY codigo_http ");
            while (miResulSet.next()){
                
                vectorCodigoHttp.addElement(miResulSet.getString("mi_codigo"));
                vectorHitsCodigoHttp.addElement(miResulSet.getInt("hits"));
                //vectorTransferencia.addElement(miResulSet.getInt("transferencia"));
            }

        }catch (Exception e){
            System.out.println("Problemas para crear grafico STATUS CODE: "+e.getMessage());
        }
    }
    
    public void CrearDatosCodigosHttp(){//crear datos para construir grafico tipo archivo
        
            for(int i=0;i<vectorCodigoHttp.size();i++){
                //vectorTipoArchivo.setElementAt(vectorTipoArchivo.elementAt(i).toString()+" - "+vectorHitsPieChart.elementAt(i).toString()+" Hits", i);
                vectorValoresCodigoHttp.addElement(Integer.parseInt(vectorHitsCodigoHttp.elementAt(i).toString()));//hits
            }
            CrearGraficoCodigosHttp();
    }
     
    private void CrearGraficoCodigosHttp(){//crear grafico en la clase CrearGraficos.java
        //grafico piechart
       
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = jPanelCodigoHttp.getSize();//toma el tamaño del contenedor

        migrafico.crear_grafico_pieChart(d, vectorCodigoHttp, vectorValoresCodigoHttp,"HTTP STATUS CODES","Hits");
        //se crea un jlabel para colocar el grafico
        jPanelCodigoHttp.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        jPanelCodigoHttp.add(chartPanel);

        jPanelCodigoHttp.repaint();
        this.repaint();
    }
    
    //////////////////////////////////////////////////////////////////////////////////
    //graficar extensiones
    private void CargarDatosGraficoErrores(){//cargar datosdesde la bs
        
        String miConsulta="";
        miConsulta="SELECT codigo_http ||' - '|| tipo as mi_codigo ,hits FROM estadisticas_codigoshttp WHERE codigo_http like '4%' OR codigo_http like '5%'  ORDER BY hits desc";

        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){
                
                vectorErrores.addElement(miResulSet.getString("mi_codigo"));
                vectorHitsErrores.addElement(miResulSet.getInt("hits"));
                
                System.out.println(miResulSet.getString("extension"));
                                             
            }
           
        }catch (Exception e){
            System.out.println("Problemas para crear grafico ERROR STATUS CODE: "+e.getMessage());
        }
    }
    
    public void CrearDatosErores(){//crear datos para construir grafico extensiones
        

            for(int i=0;i<vectorErrores.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorHitsExtensiones.elementAt(i).toString()+" Hits", i);
                vectorValoresErrores.addElement(Integer.parseInt(vectorHitsErrores.elementAt(i).toString()));//hits
            }
            CrearGraficoErrores();    
    }
    
     private void CrearGraficoErrores(){//crear grafico en la clase CrearGraficos.java
        //grafico piechart
        
        CrearGraficos migrafico = new CrearGraficos();
        //tamaño del grafico
        Dimension d = jPanelErrores.getSize();//toma el tamaño del contenedor

        migrafico.crear_grafico_pieChart(d, vectorErrores, vectorValoresErrores,"ERROR CODES","Hits");

        jPanelErrores.removeAll();
        ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);

        chartPanel.setBounds(0, 0, d.width, d.height);
        jPanelErrores.add(chartPanel);

        jPanelErrores.repaint();
        this.repaint();
    }  
     
    
    
    
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoCodigosHttp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoCodigosHttp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoCodigosHttp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoCodigosHttp.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoCodigosHttp dialog = new GraficoCodigosHttp(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanelCodigoHttp;
    public static javax.swing.JPanel jPanelErrores;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables
}
