
package polaris3.Chart;

import polaris3.Statistics.uaTipos.*;
import java.awt.Dimension;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import org.jfree.chart.ChartPanel;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.uaOtros.ConfGraficoOtrosUA;
import polaris3.Statistics.uaOtros.CrearGraficos;


public class GraficoOtrosUA extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoOtrosUA confGraficoOtrosUA;
    ConfTipoGrafico confTipoGrafico;
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    
    //tipo grafico
    boolean graficoBarras=false;
    boolean graficoPastel=false;
    
    
    //vectores para graficos
    Vector vectorUserAgent=new Vector();//tipo de user agent
    Vector vectorHits=new Vector();
    Vector vectorVisitantes=new Vector();
    Vector vectorTransferencia=new Vector();
    Vector vectorValores=new Vector();
    Vector vectorSeries=new Vector();
    //modelos par los jlist
    DefaultListModel modeloListaExtensiones=new DefaultListModel();
    DefaultListModel modeloListaNombreAchivo=new DefaultListModel();
    
    public GraficoOtrosUA(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
        cargaConfiguracion();
        Configurar();
             
        if(graficoBarras==true){
            LimpiarArreglos();
            CargarDatosGrafico("ua_downloads","ua_download");
            CrearDatosGraficoBarras("DOWNLOAING TOOL","Download Tools");
            
            LimpiarArreglos();
            CargarDatosGrafico("ua_spams","ua_spam");
            CrearDatosGraficoBarras("SPAM OR BAD BOT","Spams");
            
            LimpiarArreglos();
            CargarDatosGrafico("ua_links","ua_link");
            CrearDatosGraficoBarras("LINK-, BOOKMARK-, SERVER - CHECKING","Link Checkers");
            
            LimpiarArreglos();
            CargarDatosGrafico("ua_proxys","ua_proxy");
            CrearDatosGraficoBarras("PROXYS","Proxys");
        }
        if(graficoPastel==true){
            Configurar();
            LimpiarArreglos();
            CargarDatosGrafico("ua_downloads","ua_download");
            CrearDatosGraficoPastel();
            CrearGraficoPastel("DOWNLOAING TOOL");
            
            Configurar();
            LimpiarArreglos();
            CargarDatosGrafico("ua_spams","ua_spam");
            CrearDatosGraficoPastel();
            CrearGraficoPastel("SPAM OR BAD BOT");
            
            Configurar();
            LimpiarArreglos();
            CargarDatosGrafico("ua_links","ua_link");
            CrearDatosGraficoPastel();
            CrearGraficoPastel("LINK-, BOOKMARK-, SERVER - CHECKING");
  
            Configurar();
            LimpiarArreglos();
            CargarDatosGrafico("ua_proxys","ua_proxy");
            CrearDatosGraficoPastel();
            CrearGraficoPastel("PROXYS");
    
        }
        
        nodoCorriendo=true;
    }
    
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    public void LimpiarArreglos(){
        vectorUserAgent.removeAllElements();//tipo de user agent
        vectorHits.removeAllElements();
        vectorVisitantes.removeAllElements();
        vectorTransferencia.removeAllElements();
        vectorValores.removeAllElements();
        vectorSeries.removeAllElements();
    }
    
    
    private void cargaConfiguracion(){
        serieHits=confGraficoOtrosUA.isSerieHits();
        serieTransferencia=confGraficoOtrosUA.isSerieTransferencia();
        serieVisitantes=confGraficoOtrosUA.isSerieVisitantes();
        graficoBarras=confTipoGrafico.isGraficoBarras();
        graficoPastel=confTipoGrafico.isGraficoPastel();       
        ImprimirConfiguracion();
    }
    
    private void Configurar(){             
        if(serieHits==true) strSerie="hits";
        if(serieVisitantes==true) strSerie="visitantes";
        if(serieTransferencia==true) strSerie="transferencia";
    }
    
    //graficar extensiones
    private void CargarDatosGrafico(String tabla,String columna){//cargar datosdesde la bs
        
        String miConsulta="";
        
        miConsulta="SELECT "+columna+",hits,visitantes,transferencia FROM "+tabla+" ORDER BY "+ strSerie + " desc";
        System.out.println(miConsulta);
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        
        try{
            int i=0;//obtener los dies requeste mas hits, visitados o transfer KB
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next() && i<15){
                
                double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                miTransfrencia=miResulSet.getDouble("transferencia");
                miTransfrencia=miTransfrencia/1024;//pasar a kb
                miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                vectorUserAgent.addElement(miResulSet.getString(columna));
                vectorHits.addElement(miResulSet.getInt("hits"));
                vectorVisitantes.addElement(miResulSet.getInt("visitantes"));
                vectorTransferencia.addElement(miTransfrencia);
                i++;                 
            }
            //CrearDatosGrafico();
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  grafico clase GraficoOS.java: "+e.getMessage());
        }
        
    }
    
     public void CrearDatosGraficoBarras(String titulo, String strUA){//crear datos para construir grafico
        
        
        if(serieHits==true ){//grafico de una serie (hits)
            for(int i=0;i<vectorUserAgent.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
                vectorSeries.addElement("Hits");
            }
            CrearGraficoBarras(strUA, "Hits Amount",titulo);
        }
               
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorUserAgent.size();i++){
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
                vectorSeries.addElement("Visitors");
            }
            CrearGraficoBarras(strUA, "Visitors Amount",titulo);
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorUserAgent.size();i++){
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
                vectorSeries.addElement("Transfer");
            }
            CrearGraficoBarras(strUA, "Transfer (KB)",titulo);
        }
    }
     
     public void CrearGraficoBarras(String tituloX, String tituloY, String titulo){//crear grafico en la clase CrearGraficos.java
        
        String tipoGrafico="";
        tipoGrafico="barras";
        
        if(titulo.compareTo("DOWNLOAING TOOL")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelDownload.getSize();//toma el tamaño del contenedor
            String[] datos = {titulo,tituloX,tituloY};
            migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorUserAgent, datos,tipoGrafico);
            //se crea un jlabel para colocar el grafico
            miPanelDownload.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelDownload.add(chartPanel);
            miPanelDownload.repaint();
            this.repaint();
            
        }
        if(titulo.compareTo("SPAM OR BAD BOT")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelSpam.getSize();//toma el tamaño del contenedor
            String[] datos = {titulo,tituloX,tituloY};
            migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorUserAgent, datos,tipoGrafico);
            //se crea un jlabel para colocar el grafico
            miPanelSpam.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelSpam.add(chartPanel);
            miPanelSpam.repaint();
            this.repaint();
            
        }
        if(titulo.compareTo("LINK-, BOOKMARK-, SERVER - CHECKING")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelLink.getSize();//toma el tamaño del contenedor
            String[] datos = {titulo,tituloX,tituloY};
            migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorUserAgent, datos,tipoGrafico);
            //se crea un jlabel para colocar el grafico
            miPanelLink.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelLink.add(chartPanel);
            miPanelLink.repaint();
            this.repaint();
            
        }
        if(titulo.compareTo("PROXYS")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelProxy.getSize();//toma el tamaño del contenedor
            String[] datos = {titulo,tituloX,tituloY};
            migrafico.crear_grafico_de_barras(d, vectorValores, vectorSeries, vectorUserAgent, datos,tipoGrafico);
            //se crea un jlabel para colocar el grafico
            miPanelProxy.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico,true,true,true,true,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelProxy.add(chartPanel);
            miPanelProxy.repaint();
            this.repaint();
            
        }
    }
    
     public void CrearDatosGraficoPastel(){//crear datos para construir grafico extensiones
        
        if(serieHits==true){//grafico de una serie (hits)
            for(int i=0;i<vectorUserAgent.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorHitsExtensiones.elementAt(i).toString()+" Hits", i);
                vectorValores.addElement(Integer.parseInt(vectorHits.elementAt(i).toString()));//hits
            }
            strSerie="Hits";
        }
        
        if(serieVisitantes==true){//grafico de una serie (visitantes)
            for(int i=0;i<vectorUserAgent.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorVisitantesExtensiones.elementAt(i).toString()+" Visitors", i);
                vectorValores.addElement(Integer.parseInt(vectorVisitantes.elementAt(i).toString()));//hits
            }
            strSerie="Visitors";
        }
        
        if(serieTransferencia==true){//grafico de una serie (transferencia)
            for(int i=0;i<vectorUserAgent.size();i++){
                //vectorExtensiones.setElementAt(vectorExtensiones.elementAt(i).toString()+" - "+vectorTransferenciaExtensiones.elementAt(i).toString()+" KB", i);
                vectorValores.addElement(Float.parseFloat(vectorTransferencia.elementAt(i).toString()));//hits
            }
            strSerie="KB";
        }
        
    }
    
     private void CrearGraficoPastel(String titulo){//crear grafico en la clase CrearGraficos.java
        //grafico piechart
        
        
        if(titulo.compareTo("DOWNLOAING TOOL")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelDownload.getSize();//toma el tamaño del contenedor

            migrafico.crear_grafico_pieChart(d, vectorUserAgent, vectorValores,titulo,strSerie);
            //se crea un jlabel para colocar el grafico

            miPanelDownload.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);

            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelDownload.add(chartPanel);

            miPanelDownload.repaint();
            this.repaint(); 
        }
        if(titulo.compareTo("SPAM OR BAD BOT")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelSpam.getSize();//toma el tamaño del contenedor
            migrafico.crear_grafico_pieChart(d, vectorUserAgent, vectorValores,titulo,strSerie);
            //se crea un jlabel para colocar el grafico
            miPanelSpam.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelSpam.add(chartPanel);
            miPanelSpam.repaint();
            this.repaint();      
        }
        if(titulo.compareTo("LINK-, BOOKMARK-, SERVER - CHECKING")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelLink.getSize();//toma el tamaño del contenedor
            migrafico.crear_grafico_pieChart(d, vectorUserAgent, vectorValores,titulo,strSerie);
            //se crea un jlabel para colocar el grafico
            miPanelLink.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelLink.add(chartPanel);
            miPanelLink.repaint();
            this.repaint(); 
            
        }
        if(titulo.compareTo("PROXYS")==0){
            CrearGraficos migrafico = new CrearGraficos();
            //tamaño del grafico
            Dimension d = miPanelProxy.getSize();//toma el tamaño del contenedor
            migrafico.crear_grafico_pieChart(d, vectorUserAgent, vectorValores,titulo,strSerie);
            //se crea un jlabel para colocar el grafico
            miPanelProxy.removeAll();
            ChartPanel chartPanel=new ChartPanel(migrafico.grafico1,true,true,true,false,true);
            chartPanel.setBounds(0, 0, d.width, d.height);
            miPanelProxy.add(chartPanel);
            miPanelProxy.repaint();
            this.repaint(); 
            
        }
    }
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTansferencis: "+serieTransferencia);
      
        System.out.println("---------------------------------------------------");
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        miPanelDownload = new javax.swing.JPanel();
        miPanelSpam = new javax.swing.JPanel();
        miPanelLink = new javax.swing.JPanel();
        miPanelProxy = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("User Agents");
        setAlwaysOnTop(true);

        jTabbedPane1.setFont(new java.awt.Font("Tahoma", 1, 11));

        miPanelDownload.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout miPanelDownloadLayout = new javax.swing.GroupLayout(miPanelDownload);
        miPanelDownload.setLayout(miPanelDownloadLayout);
        miPanelDownloadLayout.setHorizontalGroup(
            miPanelDownloadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 702, Short.MAX_VALUE)
        );
        miPanelDownloadLayout.setVerticalGroup(
            miPanelDownloadLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 396, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("DOWNLOAING TOOL", miPanelDownload);

        javax.swing.GroupLayout miPanelSpamLayout = new javax.swing.GroupLayout(miPanelSpam);
        miPanelSpam.setLayout(miPanelSpamLayout);
        miPanelSpamLayout.setHorizontalGroup(
            miPanelSpamLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 706, Short.MAX_VALUE)
        );
        miPanelSpamLayout.setVerticalGroup(
            miPanelSpamLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("SPAM OR BAD BOT", miPanelSpam);

        javax.swing.GroupLayout miPanelLinkLayout = new javax.swing.GroupLayout(miPanelLink);
        miPanelLink.setLayout(miPanelLinkLayout);
        miPanelLinkLayout.setHorizontalGroup(
            miPanelLinkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 706, Short.MAX_VALUE)
        );
        miPanelLinkLayout.setVerticalGroup(
            miPanelLinkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("LINK-, BOOKMARK-, SERVER - CHECKING ", miPanelLink);

        javax.swing.GroupLayout miPanelProxyLayout = new javax.swing.GroupLayout(miPanelProxy);
        miPanelProxy.setLayout(miPanelProxyLayout);
        miPanelProxyLayout.setHorizontalGroup(
            miPanelProxyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 706, Short.MAX_VALUE)
        );
        miPanelProxyLayout.setVerticalGroup(
            miPanelProxyLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );

        jTabbedPane1.addTab("PROXYS", miPanelProxy);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 711, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 428, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(GraficoOtrosUA.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(GraficoOtrosUA.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(GraficoOtrosUA.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(GraficoOtrosUA.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                GraficoOtrosUA dialog = new GraficoOtrosUA(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JPanel miPanelDownload;
    private javax.swing.JPanel miPanelLink;
    private javax.swing.JPanel miPanelProxy;
    private javax.swing.JPanel miPanelSpam;
    // End of variables declaration//GEN-END:variables
}
