
package polaris3.ReadLogs;
import java.io.*;
import javax.swing.JOptionPane;
import polaris2.graph.Nodo;
import polaris3.DataAcces.CrearTablaW3C;
import polaris3.DataAcces.CrearTablaCommonLF;
import polaris3.DataAcces.CargarRegistros;

public class IdentificarFormatoLog {

    public Nodo n=null;
    boolean nodoCorriendo=false;
    
    File miArchivoLog;
    String primeraLinea;//primera line q se lee del log
    int numeroLineas;
    static int logFormato=0;//Variable para establecer el formato del fichero log
        //Si el log es W3C Extended Log File Formats -> logFormato=1
        //Si el log es NCSA Common Log File -> logFormato=2
        //Si el log es NCSA Combined Log Format -> logFormato=3

    public IdentificarFormatoLog(String linea, File archivo, int cantidadLineas){
        miArchivoLog=archivo;
        primeraLinea=linea;
        numeroLineas=cantidadLineas;
        Es_W3C();         
    }
    
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    private void Es_W3C()//determinar si el log tiene formato W3C
    {
        String miPrimeraLinea=primeraLinea;
        
        if(miPrimeraLinea.length()>50){
            //Determinar si la primera linea del log es: #Software: Microsoft Internet Information Services
            //Entonces es un log W3C Extended Log File Formats
            miPrimeraLinea=miPrimeraLinea.substring(0, 50);//extrer subcaden
        }
        if(miPrimeraLinea.compareTo("#Software: Microsoft Internet Information Services")==0){
            logFormato=1;
            CrearTablas();
        }
        else{
            Es_CommonLogFile();
        }   
    }
    
    private void Es_CommonLogFile()//determinar si el log tiene formato Common Log File
    {
        boolean estado=false;
        String miPrimeraLinea=primeraLinea;
        
        String [] miArreglo=miPrimeraLinea.split(" ");
        
        if(miArreglo.length==10)
        {
            if(miArreglo[3].startsWith("[")){//[26/Oct/2010:10:59:42
                estado=true;
                if(miArreglo[5].startsWith("\"")){//"GET
                    estado=true;
                    if(miArreglo[7].endsWith("\"")){//HTTP/1.1"
                    
                        estado=true;
                    }else{estado=false;}
                }else{estado=false;}
            }else{estado=false;}
        }else{estado=false;}
        
        if(estado==true){
            logFormato=2;
            CrearTablas();
        }
        else
        {
            Es_Clf_Extendido();
        }
        
    }
    private void Es_Clf_Extendido()
    {
        String miPrimeraLinea=primeraLinea;
        
        String [] miArreglo=miPrimeraLinea.split(" \"");
        
        if(miArreglo.length==4){
            logFormato=3;
            CrearTablas();
        }
            
        
    }
    
    private void CrearTablas(){//instancear clase que creara la tabla con los registros logs en la bd
        System.out.println(logFormato);
        if(logFormato!=0){
            if(logFormato==1)
                //new CrearTablaW3C(miArchivoLog);
                new CargarRegistros(new javax.swing.JFrame(), true, 1,numeroLineas, miArchivoLog).setVisible(true);
            if(logFormato==2)
                //new CrearTablaCommonLF(miArchivoLog);
                new CargarRegistros(new javax.swing.JFrame(), true, 2,numeroLineas,miArchivoLog).setVisible(true);
            if(logFormato==3)
                //new CrearTablaCommonLF(miArchivoLog);
                new CargarRegistros(new javax.swing.JFrame(), true, 3,numeroLineas,miArchivoLog).setVisible(true);
            nodoCorriendo=true;
        }
        else{
            JOptionPane.showMessageDialog(null, "Log Format Error", "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        
    }

    public static int getLogFormato() {
        return logFormato;
    }
    
    
}
