
package polaris3.Statistics.ActividadEstadistica;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.image.BufferedImage;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.*;
import java.io.*;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.chart.title.TextTitle;
import org.jfree.data.category.DefaultCategoryDataset;

public class CrearGraficos {
    
    private BufferedImage _image ;//para la imagen en memoria
    public JFreeChart grafico ;// el grafico
    private Dimension d;//dimension del grafico
    
    public CrearGraficos(){
    }
    /* Crea el grafico */
    public void crear_grafico_de_barras(Dimension d, Vector v, Vector arg1, Vector arg2,String[] data,String tipoGrafico){
        this.d= d;          
        DefaultCategoryDataset dataset = new DefaultCategoryDataset();
        //se llenan los datos
        for(int i=0; i<v.size();i++){
            dataset.setValue(Float.parseFloat(v.elementAt(i).toString()), arg1.elementAt(i).toString(), arg2.elementAt(i).toString());
        }      
        System.out.println("tipo gra"+tipoGrafico);
        //se crea el grafico
        if(tipoGrafico=="barras")
            grafico = ChartFactory.createBarChart3D(data[0], data[1], data[2], dataset, PlotOrientation.VERTICAL , true, false, true);
        if(tipoGrafico=="linea")
            grafico = ChartFactory.createLineChart(data[0], data[1], data[2], dataset, PlotOrientation.VERTICAL , true, false, true);

        CategoryPlot cP = grafico.getCategoryPlot();

        cP.setBackgroundPaint(new Color(205, 205, 205));
        cP.setRangeGridlinePaint(Color.BLACK); 
        cP.setDomainGridlinesVisible(true);
        cP.setDomainGridlinePaint(Color.BLACK);
        grafico.setBorderPaint(Color.GRAY);
        grafico.setBorderVisible(true);
        grafico.setBackgroundPaint(new Color(205, 200, 177));
        grafico.getTitle().setFont(new Font("Verdana", Font.BOLD, 12));
        
        //se coloca el grafico en memoria
        _image = grafico.createBufferedImage(this.d.width,this.d.height);
        System.err.println("grafico creado");     
    }
    
    /* carga la imagen que esta en memoria en el objeto jLabel */
    public void cargar_grafico(JLabel lb){
        ImageIcon imagenFondo = new ImageIcon(_image);  
        lb.setIcon(imagenFondo);
        lb.repaint();
    }  
    /* presenta la ventana de dialogo "guardar" y salva el grafico generado en JPG */
     public void Guardar(){
       JFileChooser fileChooser = new JFileChooser();
       int result = fileChooser.showSaveDialog(null);
       if ( result == JFileChooser.APPROVE_OPTION ){ 
            try {
                //se obtiene la direccion donde se guardara la imagen
                String url = fileChooser.getSelectedFile().toString();
                //Se guarda la imagen
                ChartUtilities.saveChartAsJPEG(new File(url + ".jpg"), grafico, d.width, d.height);
            } catch (IOException ex) {
                //Logger.getLogger(grafico.class.getName()).log(Level.SEVERE, null, ex);
                
            }
        }
   }   
}
