
package polaris3.Statistics;

import java.sql.*;
import java.util.*;

import polaris2.graph.Nodo;
import polaris3.DataAcces.CargarArreglos;
import polaris3.DataAcces.MiConexion;
import polaris3.ReadLogs.AbrirLog;
import polaris3.ReadLogs.IdentificarFormatoLog;



public class CrearResumenGeneral 
{
    public Nodo n=null;
    boolean nodoCorriendo=false;
    
    //VECTORES PARA ALMACENAR CAMPOS DE TABLA CLF}
    Vector vectorHost=new Vector();//ip del cliente
    Vector vectorDateTime=new Vector();//fecha, hora y zona
    Vector vectorDate=new Vector();//fecha
    Vector vectorTime=new Vector();//hora
    Vector vectorRequest=new Vector();//solicitud HTTP - "GET /apache_pb.gif HTTP/1.0"
    Vector vectorStatusCode=new Vector();//codigo de estado HTTP
    Vector vectorBytes=new Vector();//numero de bytes transferidos
    
    //____________________________________________
    
    
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    static String nombreArchivo="";
    static int miIdLog;
    static String formatoLog="";
    static float numeroDiferenteDias=0;//numero de dias diferentes
    static float totalPeticiones=0;//numero de peticiones totales
    static float peticionesExitosas=0;//numero de Peticiones exitosas http 2xx
    static float peticionesRedireccionadas=0;//numero de peticiones redireccionadas
    static float peticionesFallidasCliente=0;//numero de peticiones fallidas por herror del cliente
    static float peticionesFallidasServidor=0;//numero de peticiones fallidas por herror del Servidor
    static double transferenciaTotal=0;//transferencia total de bytes de datos
    static float totalPaginasVistas=0;//total paginas vistas
    
    static double promedioPeticionesDia=0;//promedio de visitas por dia
    static double promedioTransferenciaDia=0;//promedio transferencia de bytes de datos por dia
    static double promedioTransferenciaPeticion=0;//promedio transferencia de bytes de datos por peticion
    static double promedioPaginasVistasDia=0;//promerdio de paginas vistas por dia
    static float numeroVisitantes=0;//numero de visitantes (ips unicas)
    
    static String fechaInicio="";
    static String fechaFin="";
    static String horaInicio="";
    static String horaFin="";
    static String intervaloTiempo="";
    
    public CrearResumenGeneral()
    {
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        
        miIdLog=IdentificarFormatoLog.getLogFormato();
        if(miIdLog==1)
            formatoLog="W3C Extended Log";
        if(miIdLog==2)
            formatoLog="Common Log File";
        System.out.println(formatoLog+ "CrearResumenGeneral.java");
        nombreArchivo=AbrirLog.getNombreArchivo();
        
        nombreArchivo=CargarArreglos.getNombreArchivo();
        
        vectorHost=CargarArreglos.getVectorHost();
        vectorDateTime=CargarArreglos.getVectorDateTime();
        vectorDate=CargarArreglos.getVectorDate();
        vectorTime=CargarArreglos.getVectorTime();
        vectorRequest=CargarArreglos.getVectorRequest();
        vectorStatusCode=CargarArreglos.getVectorStatusCode();
        vectorBytes=CargarArreglos.getVectorBytes();
        
        TotalVisitas();
        promedioPeticionesDia();
        nodoCorriendo=true;
        
    }
    
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
    public void TotalVisitas()//Obtener numero total de visitas
    {
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select count(*) from tabla_sesion");
            miResulSet.next();
            totalPeticiones=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (Numero hits)");
            System.out.println(e.getMessage());
        } 
    }
    
    public void promedioPeticionesDia()//PROMEDIO DE VISITAS POR DIA PARA CLF
    {
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select  count(distinct fecha) from tabla_sesion");
            miResulSet.next();
            numeroDiferenteDias=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (promedioPeticionesDia)");
            System.out.println(e.getMessage());
        }
        promedioPeticionesDia = (float) (totalPeticiones/numeroDiferenteDias);
        promedioPeticionesDia=RedondearValor(promedioPeticionesDia);
        PeticionesExitosas();
          
    }
    
    public void PeticionesExitosas()//numero de peticiones exitosas
    {
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select count(status_code) from tabla_sesion where status_code like '2%'");
            miResulSet.next();
            peticionesExitosas=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (peticiones exitosas)");
            System.out.println(e.getMessage());
        } 
        
        PeticionesRedireccionadas();
    }
    
    public void PeticionesRedireccionadas()//numero de peticiones fallidas
    {
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select count(status_code) from tabla_sesion where status_code like '3%'");
            miResulSet.next();
            peticionesRedireccionadas=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (peticiones exitosas)");
            System.out.println(e.getMessage());
        }
        PeticionesFallidas();
    }
    
    public void PeticionesFallidas()//numero de peticiones fallidas
    {
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select count(status_code) from tabla_sesion where status_code like '4%'");
            miResulSet.next();
            peticionesFallidasCliente=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (peticiones exitosas)");
            System.out.println(e.getMessage());
        }
        miResulSet = null;
        miStatement = null;
        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select count(status_code) from tabla_sesion where status_code like '5%'");
            miResulSet.next();
            peticionesFallidasServidor=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (peticiones exitosas)");
            System.out.println(e.getMessage());
        }
        TransferenciaTotal();  
    }
    
    public void TransferenciaTotal()//transferencia total de bytes de datos
    {
  
        String str="";
        float totalBytes=0;
        for(int i=0;i<vectorBytes.size();i++){
            str=vectorBytes.elementAt(i).toString();//convertir a string
            totalBytes=totalBytes+Float.parseFloat(str);  
        }
        transferenciaTotal=totalBytes;//transferencia en bytes
        transferenciaTotal=transferenciaTotal/1024;//transferencia total en kilobytes
        transferenciaTotal=RedondearValor(transferenciaTotal);
        PromedioTransferenciaDia();
    }
   
    public void PromedioTransferenciaDia()//promedio transferencia de bytes de datos por dia
    {
        promedioTransferenciaDia = (double) (transferenciaTotal/numeroDiferenteDias);
        promedioTransferenciaDia=RedondearValor(promedioTransferenciaDia);
        TotalPaginasVistas();
    }
    
    public void  TotalPaginasVistas()//numero total de paginas vistas
    {
        miResulSet = null;
        miStatement = null;

        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select count(*) from tabla_sesion where tipoarchivo = 'Web Page'");
            miResulSet.next();
            totalPaginasVistas=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (Numero de Visitantes)");
            System.out.println(e.getMessage());
        } 
        PromedioPaginasVistasDia();
    }
    
    public void PromedioPaginasVistasDia()//promerdio de paginas vistas por dia
    {
        promedioPaginasVistasDia=(double)(totalPaginasVistas/numeroDiferenteDias);
        promedioPaginasVistasDia=RedondearValor(promedioPaginasVistasDia);
        HoraFecha();//ojo
        
    }
    
    public void HoraFecha()//Obtener intervalo de fecha y hora del log para clf
    {
        fechaInicio=vectorDate.elementAt(0).toString();
        horaInicio=vectorTime.elementAt(0).toString();
        fechaFin=vectorDate.elementAt(vectorDate.size()-1).toString();
        horaFin=vectorTime.elementAt(vectorTime.size()-1).toString();

        intervaloTiempo=fechaInicio+" "+horaInicio+" - "+fechaFin+" "+horaFin;
            
        NumeroVisitantes();
    }
    
    public void NumeroVisitantes()//cantidad de visitantes diferentes (sesiones)
    {    
        miResulSet = null;
        miStatement = null;

        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("select  count(distinct id_sesion)  from tabla_sesion;");
            miResulSet.next();
            numeroVisitantes=miResulSet.getInt(1);
        }catch (Exception e){
            System.out.println("Error en resumen general (Numero de Visitantes)");
            System.out.println(e.getMessage());
        } 
        PromedioTranseferenciaPenticion();
    }
    
    public void PromedioTranseferenciaPenticion()// promedio de transferencia por peticion
    {
        promedioTransferenciaPeticion=totalPeticiones/transferenciaTotal; 
        promedioTransferenciaPeticion=RedondearValor(promedioTransferenciaPeticion);
        ImprimirResultados();
    }
   
    private double RedondearValor(double valor){
        double miValor=valor;
        miValor=Math.rint(miValor*1000)/1000;
        return miValor;
    }
    
    public void ImprimirResultados()
    {
        System.out.println("Total Peticiones: "+totalPeticiones);
        System.out.println("Peticiones Exitosas: "+peticionesExitosas);
        System.out.println("Peticiones Redireccionadas: "+peticionesRedireccionadas);
        System.out.println("Peticiones Fallidas (Error del Cliente): "+peticionesFallidasCliente);
        System.out.println("Peticiones Fallidas (Error del Servidor): "+peticionesFallidasServidor);
        System.out.println("Promedio de peticiones por dia: "+promedioPeticionesDia);
        System.out.println("Transferencia total (Kylobites): "+transferenciaTotal);
        System.out.println("Promedio de Transferencia por dia (Kylobites): "+promedioTransferenciaDia);
        System.out.println("Promedio de Transferencia por peticion (Kylobites): "+promedioTransferenciaPeticion);
        System.out.println("Total paginas vistas: "+totalPaginasVistas);
        System.out.println("Promedio de paginas vistas por dia: "+promedioPaginasVistasDia);
        System.out.println("Fecha de Inicio: "+fechaInicio);
        System.out.println("Hora de Inicio: "+horaInicio);
        System.out.println("Fecha Final: "+fechaFin);
        System.out.println("Hora Final: "+horaFin);
        System.out.println("Rango de Tiempo: "+intervaloTiempo);
        System.out.println("Cantidad de Visitantes: "+numeroVisitantes);
        System.out.println("Nombre Archivo: "+nombreArchivo);
    }
    
    
    ////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////
    //**getters   
    public static String getFechaFin() {
        return fechaFin;
    }

    public static String getFormatoLog() {
        return formatoLog;
    }

    public static String getHoraFin() {
        return horaFin;
    }

    public static String getHoraInicio() {
        return horaInicio;
    }

    public static String getIntervaloTiempo() {
        return intervaloTiempo;
    }

    public static int getMiIdLog() {
        return miIdLog;
    }

    public static float getNumeroDiferenteDias() {
        return numeroDiferenteDias;
    }

    public static float getNumeroVisitantes() {
        return numeroVisitantes;
    }

    public static float getPeticionesExitosas() {
        return peticionesExitosas;
    }

    public static float getPeticionesFallidasCliente() {
        return peticionesFallidasCliente;
    }

    public static float getPeticionesFallidasServidor() {
        return peticionesFallidasServidor;
    }

    public static float getPeticionesRedireccionadas() {
        return peticionesRedireccionadas;
    }

    public static double getPromedioPaginasVistasDia() {
        return promedioPaginasVistasDia;
    }

    public static double getPromedioPeticionesDia() {
        return promedioPeticionesDia;
    }

    public static double getPromedioTransferenciaDia() {
        return promedioTransferenciaDia;
    }

    public static float getTotalPaginasVistas() {
        return totalPaginasVistas;
    }

    public static float getTotalPeticiones() {
        return totalPeticiones;
    }

    public static double getTransferenciaTotal() {
        return transferenciaTotal;
    }
    
    public static String getFechaInicio() {
        return fechaInicio;
    }
    
    public static String getNombreArchivo() {
        return nombreArchivo;
    }
    
    public static double getPromedioTransferenciaPeticion() {
        return promedioTransferenciaPeticion;
    }
}
