//configurar graficos de actividad estadistica
package polaris3.Statistics.EstadisticaAccesos;

import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.ImageIcon;
import polaris2.graph.Nodo;
import polaris3.DataAcces.MiConexion;

public class ConfGraficoArchivos extends javax.swing.JDialog {
    
    public Nodo n=null;
    boolean nodoConfigurado=false;
    
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    Vector vectorTipoArchivo = new Vector();
    
    //series
    static boolean serieHits=false;
    static boolean serieVisitantes=false;
    static boolean serieTransferencia=false;
    
    //tipos de archivo
    static boolean tipoImagen=false;
    static boolean tipoAudio=false;
    static boolean tipoVideo=false;
    static boolean tipoComprimido=false;
    static boolean tipoTexto=false;
    static boolean tipoInternet=false;
    static boolean tipoPaginaWeb=false;
    static boolean tipoOtros=false;
    
    public ConfGraficoArchivos(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        this.setLocationRelativeTo(null);
         this.setIconImage(this.getImage("/media/star.png"));
        AgruparRadioButtons();
        CargarTipoArchivo();
        HabilitaradioButons();
        
    }
     public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoConfigurado(){
        if(nodoConfigurado==true){
            n.configurado=true;//cambiar color de nodo a verde
            if(n.corriendo==true)
                n.corriendo=false;//si el nodo esta corriendo y es configurado nuevamenta pasa a verde
        }
    }
    
    private void AgruparRadioButtons(){
        //agrupar radio butons 1
        grupoBotones1.add(radioBtnHits);
        grupoBotones1.add(radioBtnVisitors);
        grupoBotones1.add(radioBtnTransferencia);
        //agrupar radio butons 2
        grupoBotones2.add(opcWebPages);
        grupoBotones2.add(opcImagenes);
        grupoBotones2.add(opcAudio);
        grupoBotones2.add(opcVideo);
        grupoBotones2.add(opcTexto);
        grupoBotones2.add(opcComprimidos);
        grupoBotones2.add(opcIntenet);
        grupoBotones2.add(opcOtros);
    }
    
    private void CargarTipoArchivo(){//Cagar los tipos de archivos desde la bd
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;

        try{
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery("SELECT DISTINCT tipoarchivo FROM tabla_sesion");
            while (miResulSet.next()){       
                vectorTipoArchivo.addElement(miResulSet.getString("tipoarchivo"));
                System.out.println("Tipos de archivo--------------");
                System.out.println(miResulSet.getString("tipoarchivo"));
                System.out.println("------------------------------");
            }

        }catch (Exception e){
            System.out.println("Problemas para cargar tipos de archivo (clase ConfGraficoFile.java): "+e.getMessage());
        }     
    }
    
    private void HabilitaradioButons(){//habilitar radio butionssegun tipos de archivo registrados en el log
        for(int i=0;i<vectorTipoArchivo.size();i++){
            String tipoAchivo=vectorTipoArchivo.elementAt(i).toString();
            if(tipoAchivo.compareTo("Web Page")==0)
                opcWebPages.setEnabled(true);
            if(tipoAchivo.compareTo("Image")==0)
                opcImagenes.setEnabled(true);
            if(tipoAchivo.compareTo("Audio")==0)
                opcAudio.setEnabled(true);
            if(tipoAchivo.compareTo("Video")==0)
                opcVideo.setEnabled(true);
            if(tipoAchivo.compareTo("Text")==0)
                opcTexto.setEnabled(true);
            if(tipoAchivo.compareTo("Compressed")==0)
                opcComprimidos.setEnabled(true);
            if(tipoAchivo.compareTo("Other")==0)
                opcOtros.setEnabled(true);
            if(tipoAchivo.compareTo("Internet")==0)
                opcIntenet.setEnabled(true);        
            
        }
    }
    
    private void SeriesGrafico(){
        //seleccionar las series del grafico con radiobuton
        if(radioBtnHits.isSelected()) serieHits=true;
        else serieHits=false;
        if(radioBtnVisitors.isSelected())serieVisitantes=true;
        else serieVisitantes=false;
        if(radioBtnTransferencia.isSelected()) serieTransferencia=true;
        else serieTransferencia=false;      
    }
    
     private void TioposAchivo(){
        //seleccionar los tipos de archivo con radiobuton
        if(opcWebPages.isSelected())tipoPaginaWeb=true;
        else tipoPaginaWeb=false;
        if(opcImagenes.isSelected())tipoImagen=true;
        else tipoImagen=false;
        if(opcAudio.isSelected())tipoAudio=true;
        else tipoAudio=false;
        if(opcVideo.isSelected())tipoVideo=true;
        else tipoVideo=false;
        if(opcTexto.isSelected())tipoTexto=true;
        else tipoTexto=false;
        if(opcComprimidos.isSelected())tipoComprimido=true;
        else tipoComprimido=false;
        if(opcIntenet.isSelected())tipoInternet=true;
        else tipoInternet=false;
        if(opcOtros.isSelected())tipoOtros=true;
        else tipoOtros=false;
    }
    
    
    private void ImprimirConfiguracion(){
        System.out.println("---------------------------------------------------");
        System.out.println("serieHits: "+serieHits);
        System.out.println("serieVisitantes: "+serieVisitantes);
        System.out.println("serieTansferencis: "+serieTransferencia);
        System.out.println("Tipo pagina web: "+tipoPaginaWeb);
        System.out.println("Tipo imagen: "+tipoImagen);
        System.out.println("Tipo audio: "+tipoAudio);
        System.out.println("Tipo video: "+tipoVideo);
        System.out.println("Tipo texto: "+tipoTexto);
        System.out.println("Tipo comprimido: "+tipoComprimido);
        System.out.println("Tipo internet: "+tipoInternet);
        System.out.println("Tipo otros: "+tipoOtros);
        
        System.out.println("---------------------------------------------------");
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        grupoBotones1 = new javax.swing.ButtonGroup();
        grupoBotones2 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        opcWebPages = new javax.swing.JRadioButton();
        opcImagenes = new javax.swing.JRadioButton();
        opcVideo = new javax.swing.JRadioButton();
        opcAudio = new javax.swing.JRadioButton();
        opcTexto = new javax.swing.JRadioButton();
        opcComprimidos = new javax.swing.JRadioButton();
        opcIntenet = new javax.swing.JRadioButton();
        opcOtros = new javax.swing.JRadioButton();
        btnAceptar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        radioBtnHits = new javax.swing.JRadioButton();
        radioBtnVisitors = new javax.swing.JRadioButton();
        radioBtnTransferencia = new javax.swing.JRadioButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Settings");

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "File Type", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        opcWebPages.setSelected(true);
        opcWebPages.setText("Web Pages");
        opcWebPages.setEnabled(false);
        opcWebPages.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcWebPagesFocusGained(evt);
            }
        });

        opcImagenes.setText("Images");
        opcImagenes.setEnabled(false);
        opcImagenes.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcImagenesFocusGained(evt);
            }
        });

        opcVideo.setText("Video");
        opcVideo.setEnabled(false);
        opcVideo.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcVideoFocusGained(evt);
            }
        });

        opcAudio.setText("Audio");
        opcAudio.setEnabled(false);
        opcAudio.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcAudioFocusGained(evt);
            }
        });

        opcTexto.setText("Text");
        opcTexto.setEnabled(false);
        opcTexto.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcTextoFocusGained(evt);
            }
        });

        opcComprimidos.setText("Compressed");
        opcComprimidos.setEnabled(false);
        opcComprimidos.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcComprimidosFocusGained(evt);
            }
        });

        opcIntenet.setText("Internet");
        opcIntenet.setEnabled(false);
        opcIntenet.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcIntenetFocusGained(evt);
            }
        });

        opcOtros.setText("Others");
        opcOtros.setEnabled(false);
        opcOtros.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                opcOtrosFocusGained(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(opcWebPages)
                    .addComponent(opcVideo)
                    .addComponent(opcIntenet))
                .addGap(56, 56, 56)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(opcTexto)
                            .addComponent(opcImagenes))
                        .addGap(54, 54, 54)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(opcAudio)
                            .addComponent(opcComprimidos)))
                    .addComponent(opcOtros))
                .addGap(23, 23, 23))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(opcWebPages)
                    .addComponent(opcImagenes)
                    .addComponent(opcAudio))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(opcVideo)
                    .addComponent(opcTexto)
                    .addComponent(opcComprimidos))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(opcIntenet)
                    .addComponent(opcOtros)))
        );

        btnAceptar.setText("Accept");
        btnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAceptarActionPerformed(evt);
            }
        });

        btnCancelar.setText("Cancel");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Series Chart", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        radioBtnHits.setSelected(true);
        radioBtnHits.setText("Hits");
        radioBtnHits.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                radioBtnHitsFocusGained(evt);
            }
        });

        radioBtnVisitors.setText("Visitors");
        radioBtnVisitors.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                radioBtnVisitorsFocusGained(evt);
            }
        });

        radioBtnTransferencia.setText("Data Transfer");
        radioBtnTransferencia.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                radioBtnTransferenciaFocusGained(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(radioBtnTransferencia)
                    .addComponent(radioBtnVisitors)
                    .addComponent(radioBtnHits))
                .addContainerGap(267, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(radioBtnHits)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(radioBtnVisitors)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(radioBtnTransferencia))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, 392, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(127, 127, 127)
                        .addComponent(btnAceptar)
                        .addGap(18, 18, 18)
                        .addComponent(btnCancelar)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnAceptar)
                    .addComponent(btnCancelar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAceptarActionPerformed
    //boton aceptar
    SeriesGrafico();
    TioposAchivo();
    ImprimirConfiguracion();
    nodoConfigurado=true;
    this.setVisible(false);
}//GEN-LAST:event_btnAceptarActionPerformed

private void opcImagenesFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcImagenesFocusGained

}//GEN-LAST:event_opcImagenesFocusGained

private void opcVideoFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcVideoFocusGained

}//GEN-LAST:event_opcVideoFocusGained

private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed
    this.setVisible(false);
    this.dispose();
}//GEN-LAST:event_btnCancelarActionPerformed

private void opcWebPagesFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcWebPagesFocusGained

}//GEN-LAST:event_opcWebPagesFocusGained

private void radioBtnHitsFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_radioBtnHitsFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_radioBtnHitsFocusGained

private void radioBtnVisitorsFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_radioBtnVisitorsFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_radioBtnVisitorsFocusGained

private void radioBtnTransferenciaFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_radioBtnTransferenciaFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_radioBtnTransferenciaFocusGained

private void opcAudioFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcAudioFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_opcAudioFocusGained

private void opcTextoFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcTextoFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_opcTextoFocusGained

private void opcComprimidosFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcComprimidosFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_opcComprimidosFocusGained

private void opcIntenetFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcIntenetFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_opcIntenetFocusGained

private void opcOtrosFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_opcOtrosFocusGained
// TODO add your handling code here:
}//GEN-LAST:event_opcOtrosFocusGained


    public static boolean isSerieHits() {
        return serieHits;
    }

    public static boolean isSerieTransferencia() {
        return serieTransferencia;
    }

    public static boolean isSerieVisitantes() {
        return serieVisitantes;
    }
    
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ConfGraficoArchivos.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                ConfGraficoArchivos dialog = new ConfGraficoArchivos(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAceptar;
    private javax.swing.JButton btnCancelar;
    private javax.swing.ButtonGroup grupoBotones1;
    private javax.swing.ButtonGroup grupoBotones2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JRadioButton opcAudio;
    private javax.swing.JRadioButton opcComprimidos;
    private javax.swing.JRadioButton opcImagenes;
    private javax.swing.JRadioButton opcIntenet;
    private javax.swing.JRadioButton opcOtros;
    private javax.swing.JRadioButton opcTexto;
    private javax.swing.JRadioButton opcVideo;
    private javax.swing.JRadioButton opcWebPages;
    private javax.swing.JRadioButton radioBtnHits;
    private javax.swing.JRadioButton radioBtnTransferencia;
    private javax.swing.JRadioButton radioBtnVisitors;
    // End of variables declaration//GEN-END:variables

    public static boolean isTipoAudio() {
        return tipoAudio;
    }

    public static boolean isTipoComprimido() {
        return tipoComprimido;
    }

    public static boolean isTipoImagen() {
        return tipoImagen;
    }

    public static boolean isTipoInternet() {
        return tipoInternet;
    }

    public static boolean isTipoOtros() {
        return tipoOtros;
    }

    public static boolean isTipoPaginaWeb() {
        return tipoPaginaWeb;
    }

    public static boolean isTipoTexto() {
        return tipoTexto;
    }

    public static boolean isTipoVideo() {
        return tipoVideo;
    }

}
