
package polaris3.Statistics.RefDominios;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.image.BufferedImage;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.*;
import java.io.*;
import java.text.NumberFormat;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.labels.StandardPieSectionLabelGenerator;
import org.jfree.chart.labels.StandardPieToolTipGenerator;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.general.DefaultPieDataset;

public class CrearGraficos {
    
    private BufferedImage _image ;//para la imagen en memoria
    private BufferedImage _image1 ;//para la imagen en memoria
    public JFreeChart grafico ;// el grafico
    public JFreeChart grafico1 ;// el grafico
    private Dimension d;//dimension del grafico
    private Dimension d1;//dimension del grafico
    
    public CrearGraficos(){
    }
    /* Crea el grafico */
    public void crear_grafico_de_barras(Dimension d, Vector v, Vector arg1, Vector arg2,String[] data,String tipoGrafico){
        this.d= d;          
        DefaultCategoryDataset dataset = new DefaultCategoryDataset();
        //se llenan los datos
        for(int i=0; i<v.size();i++){
            dataset.setValue(Float.parseFloat(v.elementAt(i).toString()), arg1.elementAt(i).toString(), arg2.elementAt(i).toString());
        }      
        System.out.println("tipo gra"+tipoGrafico);
        //se crea el grafico
        if(tipoGrafico=="barras")
            grafico = ChartFactory.createBarChart3D(data[0], data[1], data[2], dataset, PlotOrientation.HORIZONTAL , true, true, true);
        if(tipoGrafico=="linea")
            grafico = ChartFactory.createLineChart(data[0], data[1], data[2], dataset, PlotOrientation.VERTICAL , true, false, true);

        CategoryPlot cP = grafico.getCategoryPlot();

        cP.setBackgroundPaint(new Color(205, 205, 205));
        cP.setRangeGridlinePaint(Color.BLACK); 
        cP.setDomainGridlinesVisible(true);
        cP.setDomainGridlinePaint(Color.BLACK);
        cP.setNoDataMessage("No data available");
        
        //BarRenderer3D miRenderer =new BarRenderer3D();
        
        grafico.setBorderPaint(Color.GRAY);
        grafico.setBorderVisible(true);
        grafico.setBackgroundPaint(new Color(205, 200, 177));
        grafico.getTitle().setFont(new Font("Verdana", Font.BOLD, 12));
        
        
        
        //se coloca el grafico en memoria
        _image = grafico.createBufferedImage(this.d.width,this.d.height);
        System.err.println("grafico creado");     
    }
    
    public void crear_grafico_pieChart(Dimension d,Vector tipo, Vector valores, String titulo,String nomSerie){
        this.d1= d;  
        DefaultPieDataset dataset = new DefaultPieDataset();
        
        //se llenan los datos
        for(int i=0; i<tipo.size();i++){
            dataset.setValue(tipo.elementAt(i).toString(), Float.parseFloat(valores.elementAt(i).toString()));
            System.out.println(tipo.elementAt(i).toString());
            System.out.println("xx");
        }  
        
        grafico1 = ChartFactory.createPieChart3D(titulo,dataset,true,true,false);
        
        PiePlot3D plot = (PiePlot3D) grafico1.getPlot();
        plot.setLabelFont(new Font("Arial", Font.PLAIN, 12));
        plot.setNoDataMessage("No data available");
        plot.setCircular(true);
        plot.setForegroundAlpha(0.7f);//Transpaencia
        plot.setBackgroundAlpha(0.8f);
        plot.setLabelGap(0.02);
        plot.setLabelPaint(Color.BLACK);//colr letra
        plot.setLabelBackgroundPaint(Color.WHITE);//fondo delas etiquetas
        plot.setBackgroundPaint(new Color(205, 205, 205));
        plot.setLabelGenerator(new StandardPieSectionLabelGenerator(
            "{0} = {1} "+nomSerie, NumberFormat.getNumberInstance(), NumberFormat.getPercentInstance()
        ));
        plot.setToolTipGenerator(new StandardPieToolTipGenerator("{0} = {2}"));
        //grafico1.getLegend().setPosition(RectangleEdge.RIGHT);
        grafico1.setBackgroundPaint(new Color(205, 200, 177));
        grafico1.setBorderVisible(true);
        grafico1.setBackgroundPaint(new Color(205, 200, 177));
        
        _image1 = grafico1.createBufferedImage(this.d1.width,this.d1.height);
        
        System.err.println("grafico creado");    
    }
    
    /* carga la imagen que esta en memoria en el objeto jLabel */
    public void cargar_grafico(JLabel lb){
        ImageIcon imagenFondo = new ImageIcon(_image);  
        lb.setIcon(imagenFondo);
        lb.repaint();
    }  
    /* carga la imagen que esta en memoria en el objeto jLabel */
    public void cargar_grafico1(JLabel lb){
        ImageIcon imagenFondo = new ImageIcon(_image1);  
        lb.setIcon(imagenFondo);
        lb.repaint();
    }  
    /* presenta la ventana de dialogo "guardar" y salva el grafico generado en JPG */
     public void Guardar(){
       JFileChooser fileChooser = new JFileChooser();
       int result = fileChooser.showSaveDialog(null);
       if ( result == JFileChooser.APPROVE_OPTION ){ 
            try {
                //se obtiene la direccion donde se guardara la imagen
                String url = fileChooser.getSelectedFile().toString();
                //Se guarda la imagen
                ChartUtilities.saveChartAsJPEG(new File(url + ".jpg"), grafico, d.width, d.height);
            } catch (IOException ex) {
                //Logger.getLogger(grafico.class.getName()).log(Level.SEVERE, null, ex);
                
            }
        }
   }   
}
