
package polaris3.Table;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Image;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JList;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import polaris2.graph.Nodo;
import polaris3.DataAcces.CargarArreglos;
import polaris3.DataAcces.MiConexion;
import polaris3.Statistics.RefDominios.ConfGraficoDominios;
import polaris3.ReadLogs.AbrirLog;

public class TablaDominios extends javax.swing.JDialog {

    public Nodo n=null;
    boolean nodoCorriendo;

    ConfGraficoDominios confGraficoDominios;
    
    String nombreArchivo="";//url del log
    String formatoLog="";//formato del log
    
     //modificar ancho de columnas y centrar
    DefaultTableCellRenderer miTableCellenderer = new DefaultTableCellRenderer();
    DefaultTableModel miModelo;//tabla 
    
    //acceso a bd
    private Connection conexion=null;
    MiConexion miConexion=new MiConexion();
    ResultSet miResulSet;
    Statement miStatement;
    
    String tipoArchivo="";
    String strSerie="";//hits, visitantes o transferencia
    
    //series
    boolean serieHits=false;
    boolean serieVisitantes=false;
    boolean serieTransferencia=false;
    
    Vector filaTabla=new Vector();
    
    public TablaDominios(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        cargaConficuacion();
        Configurar();
        lblLog.setText(nombreArchivo + " - " + formatoLog);  
        CrearTabla();
        this.setLocationRelativeTo(null);
        this.setIconImage(this.getImage("/media/star.png"));
        
        nodoCorriendo=true;
    }
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }
    public void NodoCorriendo(){
        if(nodoCorriendo==true)
            n.corriendo=true;
    }
    
     private void CrearTabla(){
        String strColumnaCantidad="";
        if(strSerie.compareTo("hits")==0) strColumnaCantidad="HITS";
        if(strSerie.compareTo("visitantes")==0) strColumnaCantidad="VISITORS";
        if(strSerie.compareTo("transferencia")==0) strColumnaCantidad="DATA TRANSFER (KB)";

        String[] nombresColumnas = {"DOMAIN",strColumnaCantidad};
        Object[][] datos=null ;
        miModelo=null;
        miModelo = new DefaultTableModel(datos, nombresColumnas)//celdaas no editables
         {@Override
             public boolean isCellEditable (int fila, int columna) {
                 if (columna > 10)
                     return true;
                 return false;
             }
         };
        //__LLENAR DATOS EN LA TABLA___________________________________________
        CargarDatosTabla();
        //_____________________________________________________________________
        miTabla.setModel(miModelo); 
        
        TableColumn miColumna;
        
        for (int i = 0; i < 2; i++) {
            miColumna = miTabla.getColumnModel().getColumn(i);
            if(i == 0) miColumna.setPreferredWidth(250); //COLUMNA HOST
	    if(i == 1) miColumna.setPreferredWidth(30); //COLUMNA CANTIDAD

        }   
        miTabla.setDefaultRenderer (Object.class, new MiRenderAF3());
        
        
    }
     
    public void cargaConficuacion(){
        serieHits=confGraficoDominios.isSerieHits();
        serieTransferencia=confGraficoDominios.isSerieTransferencia();
        serieVisitantes=confGraficoDominios.isSerieVisitantes();
    }
    
    private void Configurar(){
             
        if(serieHits==true)
            strSerie="hits";
        if(serieVisitantes==true)
            strSerie="visitantes";
        if(serieTransferencia==true)
            strSerie="transferencia";
        
        nombreArchivo=AbrirLog.getNombreArchivo();
        formatoLog=CargarArreglos.getFormatoLog();

    }
    
    //graficar extensiones
    private void CargarDatosTabla(){//cargar datosdesde la bs
        System.out.println(strSerie);
      
        String miConsulta="";
        
        miConsulta="SELECT nombre,"+strSerie+" FROM est_dominios ORDER BY "+ strSerie + " desc";
        System.out.println(miConsulta);
        conexion=miConexion.getConexion();//abro la conexion a la base de datos 
        miResulSet = null;
        miStatement = null;
        try{
            
            miStatement = conexion.createStatement();
            miResulSet = miStatement.executeQuery(miConsulta);
            while (miResulSet.next()){
                Object [] fila = new Object[2]; // Hay 5 columnas en la tabla
                
                if(strSerie.compareTo("transferencia")==0){
                    
                    double miTransfrencia=0;//para pasar a kb y redondear a 0.00
                    miTransfrencia=miResulSet.getDouble("transferencia");
                    miTransfrencia=miTransfrencia/1024;//pasar a kb
                    miTransfrencia=Math.rint(miTransfrencia*1000)/100;//redondear
                
                    //Se rellena cada posición del array con una de las columnas de la tabla en base de datos.
                    for (int i=0;i<1;i++)//columna 0,1,2,3
                        fila[i] = miResulSet.getString(i+1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.
                    fila[1]=miTransfrencia;//columna 4: transferncia en kb
                }else{
                    for (int i=0;i<2;i++)//columna 0,1,2,3
                        fila[i] = miResulSet.getString(i+1); // El primer indice en rs es el 1, no el cero, por eso se suma 1.                   
                }
 
                miModelo.addRow(fila);                      
            }
            
        }catch (Exception e){
            System.out.println("Problemas para cargar datos de  tabla clase TablaEstadisticasDominios.java: "+e.getMessage());
        }
 
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        miTabla = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        lblProcess1 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        lblLog = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Domains");
        setAlwaysOnTop(true);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Result", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        miTabla.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        miTabla.setCellSelectionEnabled(true);
        miTabla.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                miTablaMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(miTabla);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 555, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 234, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel4.setText("Process");

        lblProcess1.setFont(new java.awt.Font("Tahoma", 1, 11));
        lblProcess1.setText("Domains Statistics");
        lblProcess1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel5.setText("Web Server Log");

        lblLog.setFont(new java.awt.Font("Tahoma", 1, 11));
        lblLog.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(47, 47, 47)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel5)
                    .addComponent(jLabel4))
                .addGap(18, 18, 18)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(lblLog, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(lblProcess1, javax.swing.GroupLayout.DEFAULT_SIZE, 358, Short.MAX_VALUE))
                .addContainerGap(63, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5)
                    .addComponent(lblLog, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblProcess1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void miTablaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miTablaMouseClicked
   
}//GEN-LAST:event_miTablaMouseClicked

    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(TablaDominios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(TablaDominios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(TablaDominios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(TablaDominios.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the dialog */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                TablaDominios dialog = new TablaDominios(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel lblLog;
    private javax.swing.JLabel lblProcess1;
    private javax.swing.JTable miTabla;
    // End of variables declaration//GEN-END:variables
}
class MyCellRenderer3 extends  DefaultListCellRenderer {
        public MyCellRenderer3() {
            setOpaque(true);
        }
        Color currColor=Color.white;  
        public Component getListCellRendererComponent( JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
        if(index%2==0) {                              
            currColor=Color.LIGHT_GRAY;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(list.getSelectionForeground());  
            super.setBackground(list.getSelectionBackground());  
        } else {  
            super.setForeground(Color.BLACK);     
            super.setBackground(currColor);  
        }           
        setFont(list.getFont());                                  
            return this;
        }
    }

//clase para cambiar la apariencia de las tablas
class MiRenderAF3 extends DefaultTableCellRenderer{
    
    Color currColor=Color.white;  
    
    public Component getTableCellRendererComponent(JTable table,Object value,boolean isSelected,boolean hasFocus,int row,int column)
    {
        super.getTableCellRendererComponent (table, value, isSelected, hasFocus, row, column);
        this.setOpaque(true);
        table.setShowGrid(true);
        
        //cambiar fuente de cabeseras
        JTableHeader th = table.getTableHeader(); 
        Font fuente = new Font("Verdana", Font.BOLD, 12); 
        th.setFont(fuente); 
       // th.setBackground(new Color(153,153,255));
        
        //alternar color de filas
        if(row%2==0) {                              
            currColor=Color.white;  
        }      
        else {  
            currColor=new Color(222,222,255);                  
        }                              
        if(isSelected) {  
            super.setForeground(table.getSelectionForeground());  
            super.setBackground(table.getSelectionBackground());  
        } else {  
            super.setForeground(Color.black);     
            super.setBackground(currColor);  
        }                         
        setFont(table.getFont());                                  
        setValue(value);  
        
        //alinear columnas
        super.setHorizontalAlignment(SwingConstants.LEFT);
     
        //resisables
       // table.getColumnModel().getColumn(0).setResizable(false);
        //table.getColumnModel().getColumn(1).setResizable(false);
        //table.getColumnModel().getColumn(2).setResizable(false);
        //table.getColumnModel().getColumn(3).setResizable(false);
        //table.getColumnModel().getColumn(4).setResizable(false);
        return this;
   }
}