
package workspace.Classification.settings;

import java.awt.Color;
import java.awt.Image;
import javax.swing.ImageIcon;
import workspace.Main_Set.Main;

public class FrmClassification extends javax.swing.JDialog {
   //se instancia el ClassificationNode, archivo que contiene todas las configuraciones
   //respectivas a classification y que a su vez hereda de SimpleNode
    private SimpleClassificationNode cn;
    
    //configuraciones iniciales de este formulario
    public FrmClassification(java.awt.Frame parent, SimpleClassificationNode nodo) {
        super(parent, true);
        initComponents();
        this.setIconImage(this.getImage("/media/star.png"));
        //la instanciacion recibe un nodo 
        this.cn = nodo;  
        //muestra el combo del target y el valor seleccionado        
        this.lst_target.setSelectedItem(this.cn.getTarget());
    }   
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel2 = new javax.swing.JLabel();
        lst_target = new javax.swing.JComboBox();
        btnAccept = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Classification Settings");
        jLabel2.setText("Target Class");

        lst_target.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Select a target class", "Ip type", "Schedule", "Week day", "Duration", "Request amount", "Download size" }));

        btnAccept.setText("Accept");
        btnAccept.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAcceptActionPerformed(evt);
            }
        });

        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lst_target, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnAccept)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnCancel)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(lst_target, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnAccept)
                    .addComponent(btnCancel))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    //manejo de conos ********************************************************
       
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
//manejo de conos ********************************************************
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        //la ventana se hace invisible y se valida, si el ya esta configurado
        //que continue configiurado y con borde azul, de lo contrario que 
        //mantega su estado como no configurado
        this.setVisible(false);   
        if(this.cn.isConfigured() == true) {
            this.cn.setConfigured(true);
            this.cn.setBorderColor(new Color(0,0,255));
        } else {
            this.cn.setConfigured(false);
            this.cn.setBorderColor(new Color(0,0,0));
        }                       
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnAcceptActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAcceptActionPerformed
        //se retorna el valor de la clase target 
        this.cn.setExecuted(false);
        this.cn.setTarget(this.lst_target.getSelectedItem().toString());   
        //si el usuario hace clic en aceptar entonces el  nodo cambia la bandera
        //configured a verdadero y hace que el
        //borde del nodo se torne azul, toma la clase traget; 
        //siempre que este sea difernte de "Select a target class"             
        if (this.cn.getTarget() != "Select a target class") {
            //el color del borde se hace azul
            this.cn.setBorderColor(new Color(0,0,255));
            //la bandera de configuracion se hace verdadera
            this.cn.setConfigured(true);                        
            //se muestra el valor de la clase target
            System.out.println(" the target class is: " + this.cn.getTarget());
            //la ventana desaparece
            this.setVisible(false);
        }
        //pero si el  valor de la sesion es "Select a target class"
        //el borde se torna negro y la bandera se hace falsa
        else {
            this.cn.setTarget("Select a target class");
            this.cn.setBorderColor(new Color(0,0,0));
        }                    
    }//GEN-LAST:event_btnAcceptActionPerformed

  
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAccept;
    private javax.swing.JButton btnCancel;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JComboBox lst_target;
    // End of variables declaration//GEN-END:variables
    
}
