//el archivo contiene las configuraciones correspondientes a la seleccin umbral
//desde preprocesamiento

package workspace.Prepro;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.ImageIcon;
import prePro.ejecutarPrepro;
import workspace.Main_Set.SimpleNode;
import workspace.Source.SelectSourceNode;

public class UmbralNode extends SimpleNode{
    
    private Class<?>[] clases;
    private ArrayList<SimpleNode> nodos;
    public boolean configured = false;
    public boolean executed   = false;
    public boolean mfr = false;  
    public String minutes = "Select a value"; 
    public String pathLogServer = "";
    public int tipoL;    
    
    public UmbralNode(Point center) {
        this.setCenter(center);
        this.setDimension(new Dimension(80,60));
        this.clases = new Class<?>[1];
        //solo recibe select source
        this.clases[0] = SelectSourceNode.class;
        this.nodos = new ArrayList();
    }
        
    public Class<?>[] getValidInputClasses(){
        return this.clases;
    }
    
    public ArrayList<SimpleNode> getInputNodes(){
        return this.nodos;
    }
    
    public Image getImage(){
        return new ImageIcon(System.class.getResource("/media/prepro1.png")).getImage();
    }
    
    public String getString(){
        return "GAP Session";
    }
    
    //si el nodo puede ser conectado, entonces se anade un nodo
    public void connect(SimpleNode n){
        if(this.canConnect(n)){
            this.nodos.add(n);
        }
    }
    
    public void disconnect(SimpleNode n){
        this.nodos.remove(n);
        this.setBorderColor(null);
    }
    
     public boolean canConfigure(){
        return true;
    }
     
     public void configure() {
        FrmGAP u = new FrmGAP(null,(UmbralNode)getSelf());
        u.setLocationRelativeTo(u.getParent());
        u.setVisible(true);
        getParent().repaint();
    }
     
    public boolean canExecute() {
        return true;
    }
    
    public void execute() {
        ejecutarPrepro runPrepro;
        if (this.isConfigured() == true){
            getParent().repaint();
            if(getInputNodes().size() == 0){               
                getParent().showError("Please, select a source");                
                this.setExecuted(false);
                return;
            }
            SelectSourceNode ss = (SelectSourceNode)getInputNodes().get(0);
            //*******************************************************************
            /*aqui se instancia el selectsoruce y se toma la ruta*/
            //*******************************************************************            
            this.setPathLogServer(ss.getPath());
            System.out.println(" From Umbral, the path ; " + this.getPathLogServer());
            this.setTipoL(ss.getTipoL());
            System.out.println(" From Umbral, the tipoL ; " + this.getTipoL());
            
            if(ss.isExecuted() == false){
                getParent().showError("Please, excute the Web Server first");
                //validacion para las baderas ejecucion, configuracion y el color del borde
                this.setExecuted(false);
                if(this.isConfigured() == false){
                    this.setConfigured(false);
                    setBorderColor(null);
                } else{
                    this.setConfigured(true);
                    setBorderColor(new Color(0,0,255));
                }
                return;
            }
            //la bandera es true
            // *** Polaris *** Johana ***
            long time = System.currentTimeMillis();
            //
            int tiempoS= Integer.parseInt(this.getTsesion());
            runPrepro= new ejecutarPrepro(this.getPathLogServer(),ss.getIndicesExt(ss.getVectorExt()),ss.getCuantos(),tiempoS);
            runPrepro.hacerTransfor(); // Hacer transformacion
            if(this.getTipoL()==1 || this.getTipoL()==3) runPrepro.hacerSesionComun(2); // Hacer Sesion Comun pa todos
            if(this.getTipoL()==2){
                runPrepro.setMFR(this.isMfr());
                runPrepro.hacerSesionExt(2); // Hacer Sesion Extendida solo para extendida
            }            
            this.setMsg("UMBRAL NODE EXECUTED: " + runPrepro.getMensaje());
            // MANDAR MENSAJE
            long executionTime = System.currentTimeMillis() - time;                       
            System.out.println("Umbral tiempo: " + executionTime);
            // *** Finished ***
            this.setExecuted(true);
            setBorderColor(new Color(0,255,0));
            getParent().repaint();
        } else {
            this.getParent().showError("First configure, after execute");
            //cuando no esta configurado
            this.setExecuted(false);
           if(this.isConfigured() == false){
                this.setConfigured(false);
                setBorderColor(null);
            } else{
                this.setConfigured(true);
                setBorderColor(new Color(0,0,255));
            }
            getParent().repaint();
        }        
    }
    
    //comprobacion MFR el valor se pasa como parametro
    public boolean isMfr() {
        return mfr;
    }    
    public void setMfr(boolean mfr) {
        this.mfr = mfr;
    } 
    
    //se pasa el valor de la sesion en minutos como parametro
    public String getTsesion() {
        return getMinutes();
    }    
    public void setTsesion(String minutes) {
        this.setMinutes(minutes);
    }   

    //el valor de la sesion en minutos como parametro
    public String getMinutes() {
        return minutes;
    }

    public void setMinutes(String minutes) {
        this.minutes = minutes;
    }

    //transferencia de parametros desde select source
    public String getPathLogServer() {
        return pathLogServer;
    }

    public void setPathLogServer(String pathLogServer) {
        this.pathLogServer = pathLogServer;
    }

    public int getTipoL() {
        return tipoL;
    }

    public void setTipoL(int tipoL) {
        this.tipoL = tipoL;
    }

    public boolean isConfigured() {
        return configured;
    }

    public void setConfigured(boolean configured) {
        this.configured = configured;
    }
   
       
}
