/**formulario lanzado por la seleccion de fuente*/

package workspace.Source;

import java.awt.Color;
import java.awt.Image;
import java.io.File;
//import java.io.FileFilter;
import java.io.IOException;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.filechooser.FileFilter;
import javax.swing.JFileChooser;
import workspace.Main_Set.Main;

public class FrmSourceSelect extends javax.swing.JDialog {
    /**se define el selectsource, archivo que contiene la configuracion del
    * log server*/
    private SelectSourceNode ss;   
    private FrmEx fe;

    public FrmSourceSelect(java.awt.Frame parent, SelectSourceNode nodo) {
        /**como el formulario es un jDialog entonces necesita definir el parent
        * o ventana antecesora, la cual quedara bloqueada mientras este
        * formulario este vigente; esto se logra a traves del jDialog*/
        super(parent, true);
        initComponents();
        this.setIconImage(this.getImage("/media/star.png"));
        /**se instancia un nodo*/
        ss = nodo;               
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        btnOpen = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        btnExt = new javax.swing.JButton();
        btnOk = new javax.swing.JButton();
        lbl_state = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Select Source");
        btnOpen.setText("Open Source");
        btnOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOpenActionPerformed(evt);
            }
        });

        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnExt.setText("Extensions");
        btnExt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnExtActionPerformed(evt);
            }
        });

        btnOk.setText("Accept");
        btnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkActionPerformed(evt);
            }
        });

        lbl_state.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(btnExt, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(30, 30, 30)
                        .addComponent(btnOk, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(16, 16, 16)
                        .addComponent(btnCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 17, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnOpen, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lbl_state, javax.swing.GroupLayout.DEFAULT_SIZE, 238, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnExt)
                    .addComponent(btnOpen))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancel)
                    .addComponent(btnOk))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbl_state, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkActionPerformed
       System.out.println("file: " + ss.getPath());
        if(ss.getPath()!=null && ss.getVectorExt().size()>0){
            this.ss.setExecuted(false);
            //
            this.ss.setBorderColor(new Color(0,0,255));
            this.ss.setConfigured(true);
            this.setVisible(false);            
        }
        else{
            if(ss.getPath()==null) lbl_state.setText("File Name is missed...");
            if(ss.getVectorExt().size()==0) lbl_state.setText("Extensions are missed...");
            if(ss.getPath()==null && ss.getVectorExt().size()==0) lbl_state.setText("EveryThing is missed...");
        }
    }//GEN-LAST:event_btnOkActionPerformed
    
    /**manejo de iconos ********************************************************/
    
    public Image getImage(String classpath){
        return new ImageIcon(this.getClass().getResource(classpath)).getImage();
    }

    private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = Main.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
        
    }
    
/**manejo de conos ********************************************************/        
    
    private void btnExtActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnExtActionPerformed
        /**al seleccionar las extensiones se habilita el boton seleccionar fuente
        * se muestra el formulario de selectsource*/
        Vector datExt;
        FrmEx fe = new FrmEx(null,true,ss.getVectorExt());
        /**centrar*/
        fe.setLocationRelativeTo(fe.getParent());
        /**se hace visible el form*/        
        fe.setVisible(true); 
        /**aqui se carga el vector de extensiones*/
        datExt= fe.getVector();
        ss.setVectorExt(datExt);
        //
        if(ss.getVectorExt().size()>0) {
            lbl_state.setText("Extensions Save...");
        }else{
            lbl_state.setText("Extensions don't save...");
        }      
    }//GEN-LAST:event_btnExtActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        /**boton cancelar*/            
        this.setVisible(false);
        /**validacion para no cambiar los la configuracion cuando el nodo esta
        * configurado o ejecutado y se oprime el boton cancelar*/
        if (this.ss.isConfigured() == true) {
            this.ss.setConfigured(true);
            this.ss.setBorderColor(new Color(0,0,255));
            if (this.ss.isExecuted() == true){
                this.ss.setExecuted(true);
                this.ss.setBorderColor(new Color(0,255,0));
            }
        }
    }//GEN-LAST:event_btnCancelActionPerformed
    
    private void btnOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOpenActionPerformed
        // ***
        
        if(this.fe==null){
            System.out.println("es nulo");
        }
        this.ss.setExecuted(false);
    
        /**en esta evento se efecta la llamada a abrir log*/
        JFrame jf = (JFrame)null;
        /**se instancia el JFileChooser*/
        JFileChooser file = new JFileChooser("D:/polaris/datosprueba");
        /**centrar*/
//        file.setLocation()        
//        iv.setLocationRelativeTo(iv.getParent());
        //
        file.setVisible(true);
        file.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
        file.setAcceptAllFileFilterUsed(true);
        /**lo anadi para poder visualizar todos los archivos y carpetas*/
        file.getAcceptAllFileFilter();
        /*los filtros que visualizan las extensiones aceptables
        file.addChoosableFileFilter(new FileFilter(){
            public String getDescription(){
                return "*.log";
            }
            public boolean accept(File f){
                return (!f.isDirectory())&&(f.getAbsolutePath().endsWith("log"));
            }
        });
        file.addChoosableFileFilter(new FileFilter(){
            public String getDescription(){
                return "*.txt";
            }
            public boolean accept(File f){
                return (!f.isDirectory())&&(f.getAbsolutePath().endsWith("txt"));
            }
        });*///cierra las lineas que hacen referencia a filtros
        int res = file.showOpenDialog(this);
        if(res==JFileChooser.APPROVE_OPTION){
            /**se visualiza el archivo seleccionado*/
            System.out.println(" from FrmSourceSelect.java " + file.getSelectedFile().getAbsolutePath());            
            try {
                this.ss.setPath(file.getSelectedFile().getCanonicalPath());
                lbl_state.setText("File Name Save...");
            } catch (IOException ex) {
                ex.printStackTrace();
                lbl_state.setText("File Name don't save...");
            }        
       }        
    }//GEN-LAST:event_btnOpenActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnExt;
    private javax.swing.JButton btnOk;
    private javax.swing.JButton btnOpen;
    private javax.swing.JLabel lbl_state;
    // End of variables declaration//GEN-END:variables
    
}
