/**configuraciones del select source*/
package workspace.Source;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.ImageIcon;
import prePro.ejecutarPrepro;
import workspace.Main_Set.SimpleNode;

public class SelectSourceNode extends SimpleNode{
    public boolean configured = false;
    public boolean executed   = false;
    /**se define la variable que guarda la ruta*/
    public String path;
    public int tipoL;
    public int tam = 0;
    public Vector vectorExt = new Vector(60);   
    int cuantos;    
    //
    
    /**la definicion de esta clase pasa como paramentro un punto central, el cual
    * ayudara para identificar si el clic esta dentro del cuadro o no*/
    public SelectSourceNode(Point center) {
        /**se establece un centro*/
        this.setCenter(center);
        /**se redimensiona*/
        this.setDimension(new Dimension(80,60));
    }
    
    /**clases validas de entrada; ninguna porque es el nodo inicial*/
    public Class<?>[] getValConfigidInputClasses(){
        return new Class<?>[0];
    }
    
    /**Posibles nodos de conexion*/
    public ArrayList<SimpleNode> getInputNodes(){
        return new ArrayList<SimpleNode>();
    }
    
    /**la imagen del select source*/
    public Image getImage(){
        return new ImageIcon(System.class.getResource("/media/selectsource1.png")).getImage();
    }
    
    /**la cadena que le identifica*/        
    public String getString(){
        return "Web Server";
    }
    
    /**comunica si el nodo puede ser conectado, retorna falso en Configure 
    * porque es el primer objeto*/
    public boolean canConnect(SimpleNode n){
        return false;
    }
    
    /**puede ser ejecutado*/
    public boolean canExecute() {
        return true;
    }

    /**metodo ejecutar*/
    public void execute() {
        //this.setMsg("Dios te ama!!!!!");
        System.out.println("bdSettings: " + this.getLogin());
        //
        ejecutarPrepro leerLog;
        int tiempoS=0;
        /**solo se ejecuta si primero ha sido configurado*/    
        if (this.isConfigured() == true){              
            // *** Polaris *** Johana ***
            long time = System.currentTimeMillis();
            //
            System.out.println("Direccion: " + this.getPath());            
            this.setTam((this.getVectorExt().size()));
            //
            leerLog= new ejecutarPrepro(this.getPath(),this.getIndicesExt(this.getVectorExt()),cuantos,tiempoS);
            leerLog.leerFile(); // leer Archivo Plano
            this.setMsg("SOURCE NODE EXECUTED: " + leerLog.getMensaje()); // obtiene mensaje            
            this.tipoL= leerLog.getTipo(); // Sacar tipo de log
            leerLog.hacerTransfor(); // Hacer transformacion
            // MANDAR MENSAJE
            long executionTime = System.currentTimeMillis() - time;                       
            System.out.println("Source time: " + executionTime);
            //this.setMsg(this.getMsg() + " -- " + "Source time: " + executionTime + " milliseconds");
            // *** Finished ***
            /**el color de la ejecucion es verde*/
            setBorderColor(new Color(0,255,0));
            /**la bandera de ejecutado se hace verdadera*/
            this.setExecuted(true);
            /**se repinta sobre la ventana contenedora*/
            getParent().repaint();           
        } else {
            /**si no ha sido ejecutado primero, se muestra la advertencia*/
            this.getParent().showError("First configure, after execute");
            this.setExecuted(false);
            if(this.isConfigured() == false){
                    this.setConfigured(false);
                    setBorderColor(null);
                } else{
                    this.setConfigured(true);
                    setBorderColor(new Color(0,0,255));
                }    
            getParent().repaint();
        }
        ///
        
    }
    
    public int getCuantos(){
        return cuantos;
    }
    
    // *** Polaris *** Johana
    public int[] getIndicesExt(Vector extensiones){
        int[] indExt = new int[60];
        int i,j;
        String ext="";
        //
        for(i=0;i<60;i++){
            indExt[i]= 0;           
        }
        i=0;
        for(j=0;j<extensiones.size();j++){
            ext= extensiones.elementAt(j).toString();
            // -10
            if(ext.equals("HTML")) {
                indExt[i]= 9; i++;            
            }
            if(ext.equals("HTM")) {
                indExt[i]=8; i++;
            }
            if(ext.equals("PHP")) {
                indExt[i]= 22;  i++;          
            }
            if(ext.equals("JSP")) {
                indExt[i]= 20; i++;      
            }
            if(ext.equals("DOC")) {
                indExt[i]= 15; i++;  
            }
            if(ext.equals("PDF")) {
                indExt[i]= 16; i++;
            }
            if(ext.equals("ASP")) {
                indExt[i]= 1; i++;
            }
            if(ext.equals("ASPX")) {
                indExt[i]= 2; i++;
            }
            if(ext.equals("PHP4")) {
                indExt[i]= 24; i++;
            }
            if(ext.equals("TXT")) {
                indExt[i]= 29; i++;
            }                
            if(ext.equals("XML")) {
                indExt[i]= 0; i++;            
            }

        }     
        cuantos= i;
        return indExt;
    }
    // *** Finished ***
    
    /**puede ser cofigurado*/
    public boolean canConfigure(){
        return true;
    }
    
    /**metodo configurar*/
    public void configure() {        
       
        /**se muestra el formulario de selectsource*/
        FrmSourceSelect ss = new FrmSourceSelect(null,(SelectSourceNode)getSelf());
        /**centrar*/
        ss.setLocationRelativeTo(ss.getParent());
        /**se hace visible el form        */
        ss.setVisible(true);
        /**se repinta sobre la ventana contenedora*/
        getParent().repaint();        
    }

   /**se retona la ruta*/
    public String getPath() {
        return path;
    }

    /**se establece la ruta*/
    public void setPath(String path) {
        this.path = path;
    }

    /**tipoL como parametro (todavia no se para que sirve, pero lo transfiere)*/
    public int getTipoL() {
        return tipoL;
    }

    public void setTipoL(int tipoL) {
        this.tipoL = tipoL;
    }

    public boolean isConfigured() {
        return configured;
    }

    public void setConfigured(boolean configured) {
        this.configured = configured;
    }
    
     public Vector getVectorExt() {
         return vectorExt;
     }
     
     public void setVectorExt(Vector vectorExt) {
         this.vectorExt = vectorExt;
     }

    public int getTam() {
        return tam;
    }

    public void setTam(int tam) {
        this.tam = tam;
    }    
       
}//
